#include			<stdio.h>
#include			<stdlib.h>
#include			<alloc.h>
#include			<float.h>
#include			<math.h>
#include			<float.h>
#include			<string.h>
#include			<time.h>
#include			"my_menu.h"
#include			"adeshdef.h"
#include			"adeshvar.h"
#include			"adeshsub.h"
#include			"iapdef.h"


void	show_user(void);

int	menu_read_file();				/* Routines under the FILE menu */
int	menu_save_as_cell();
int	menu_save_cell();
int	menu_list_file();
int	menu_print();
int	menu_select_and_view();
int	menu_view_type();
int   menu_dos();
int	menu_EXIT();
int menu_plane_or_atom();

int	menu_Set_current_Cell_Type();	/* CELL menu	*/
int	menu_Define_User_Unit_Cell();
int	input_unit_cell_position();
void	format_unit_cell_entry(int i, char *c_string);


int	menu_Set_Current_Atom_Type();	/* ATOM menu	*/

int	input_axes();					/* Miller indices */
int	menu_axes_type();

int	menu_subset();					/* SUBSET menu	*/
int	menu_subset_shape();
int	input_subset_limits();


int	menu_alloy_random();			/* Random Alloy menu */
int	Read_Perc_or_Number();
int	input_alloy_percentage_or_number();
int	Get_Random_Alloy_Element();
int   menu_alloy_systematic();   /* Systematic Alloy menu  */
int	input_lattice_constant();
int	input_atom_type();
void	decimal_to_fract(int *i1, int *i2, float a);
int	Set_Alloy_Atom_Type();
int	menu_alloy_make();


int	menu_dislocation();			/* DISLOCATION menu	*/
int	input_dislocation();
int	input_dislocation_XY();
int	input_dislocation_TYPE();
int	input_dislocation_ORIENTATION();
int	input_dislocation_LINE();
int	get_dislocation_type();
int	get_dislocation_orientation();
int	get_dislocation_line();
int	compute_dislocation();


int	menu_tensile();				/* STRAIN menu	*/
int	input_strain();
int	menu_shear();
int	menu_strain();

int	menu_translation();
int	menu_rotation();
int	input_rigid_displacement();	/* Rigid Volume Displacements	*/
int	input_rotation_degrees();
int	menu_rigid_displacement();
int	menu_rotational_displacement();

int 	menu_make_cell();				/* Making the cell	*/
void	compute_cell_size_param(void);
void	Set_Cell_Size(void);

int	menu_periodicity();				/* Assigning planes and periodicity	*/

int	menu_h_junction();			/* Heterojunction	*/

int	menu_retain_subset();		/* Retaining only a portion of the CC */

int	menu_energy();					/* Computing the energy	*/
int	input_boundary_TYPE();
int	menu_boundaries();
int	set_boundary();
int	menu_compute_cell_energy();

int	menu_rotate_cell();			/* Rotate CC	*/


int	menu_relax();					/* Energy minimization	*/
int	input_relax_param();
int	menu_Energy_Minimization();
int	menu_Monte_Carlo();
int menu_MC_Plot();
int	menu_SA();
int	input_MC_Plot_param();
int	menu_MC_Energy_Plot();
int	menu_atom_swap();


int menu_GB();						/* Grain boundary	*/
int	input_GB_param();
int	Make_GB();
int	Make_GB_Core();



int	menu_cell_extend();			/* Expand cell along Z axis */

int   menu_bond();					/* Adjust bond lengths and make nabors */
//int	input_bond_param();
//int	Bond_Length_Adjustment();



int	menu_IAP_Select();				/* Setting the IAP type & parameters */
int	Modify_IAP_Param();
int	Read_IAP_Param_File();
int	Save_IAP_Param_File();
int	Set_IAP_Alloy_Element_Type();
int	Set_IAP_Type();
int	Input_IAP_Param_Value();



int	menu_edit();						/* Edit atom positions */
void	set_plot_scales(float *a, float *b, float *c,
							 float *x1, float *x2, float *y1, float *y2,
							 float *z1, float *z2);



/* File operations */
VN_Menu	File_Items;
			if(Init_VN_Menu(&File_Items, "Main / File Menus", 7, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create File menu");
					exit(0);
				}

			Init_VN_Menu_Entry(&VN_Menu_Level_1, 1, "Open", menu_read_file);
			Init_VN_Menu_Entry(&VN_Menu_Level_1, 2, "Save", menu_save_cell);
			Init_VN_Menu_Entry(&VN_Menu_Level_1, 3, "Save As", menu_save_as_cell);
			Init_VN_Menu_Entry(&VN_Menu_Level_1, 4, "List", menu_list_file_risc);
			Init_VN_Menu_Entry(&VN_Menu_Level_1, 5, "Print", menu_print);
			Init_VN_Menu_Entry(&VN_Menu_Level_1, 6, "View", menu_select_and_view);
			Init_VN_Menu_Entry(&VN_Menu_Level_1, 7, "Quit", menu_exit);

/* Unit cell type */
VN_Menu Unit_Cell_Items;
			if(Init_VN_Menu(&Unit_Cell_Items, "Main / Unit Cell Menus", 5, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create Unit Cell menu");
					exit(0);
				}

			Init_VN_Menu_Entry(&Unit_Cell_Items, 1, "Simple Cubic", menu_Set_Current_Cell_Type);
			Init_VN_Menu_Entry(&Unit_Cell_Items, 2, "BCC", menu_Set_Current_Cell_Type);
			Init_VN_Menu_Entry(&Unit_Cell_Items, 3, "FCC", menu_Set_Current_Cell_Type);
			Init_VN_Menu_Entry(&Unit_Cell_Items, 4, "DC", menu_Set_Current_Cell_Type);
			Init_VN_Menu_Entry(&Unit_Cell_Items, 5, "User Defined", menu_Define_User_Unit_Cell);

/* Assign atoms to lattice locations */
VN_Menu	Atom_Items;

			if(Init_VN_Menu(&Atom_Items, "Main / Atom Menus", 104, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create Atom menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Atom_Items,  1, " Vacancy", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  2, " Hydrogen     ( H) : HEX,   1", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  3, " Helium       (He) : HEX,   2 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  4, " Lithium      (Li) : BCC,   3 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  5, " Beryllium    (Be) : HEX,   4 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  6, " Boron        ( B) : TET,   5", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  7, " Carbon       ( C) :  DC,   6 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  8, " Nitrogen     ( N) : HEX,   7", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,  9, " Oxygen       ( O) : CUB,   8", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 10, " Fluorine     ( F) : MCL,   9", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 11, " Neon         (Ne) : FCC,  10 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 12, " Sodium       (Na) : BCC,  11 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 13, " Magnesium    (Mg) : HEX,  12 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 14, " Aluminium    (Al) : FCC,  13 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 15, " Silicon      (Si) :  DC,  14 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 16, " Phosphorus   ( P) : CUB,  15 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 17, " Sulfur       ( S) : ORC,  16 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 18, " Chlorine     (Cl) : ORC,  17 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 19, " Argon        (Ar) : FCC,  18 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 20, " Potassium    ( K) : BCC,  19 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 21, " Calcium      (Ca) : FCC,  20 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 22, " Scandium     (Sc) : HEX,  21 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 23, " Titanium     (Ti) : HEX,  22 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 24, " Vanadium     ( V) : BCC,  23 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 25, " Chromium     (Cr) : BCC,  24 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 26, " Manganese    (Mn) : CUB,  25 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 27, " Iron         (Fe) : BCC,  26 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 28, " Cobalt       (Co) : HEX,  27 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 29, " Nickel       (Ni) : FCC,  28 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 30, " Copper       (Cu) : FCC,  29 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 31, " Zinc         (Zn) : HEX,  30 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 32, " Gallium      (Ga) : ORC,  31 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 33, " Germanium    (Ge) :  DC,  32 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 34, " Arsenic      (As) : RHL,  33 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 35, " Selenium     (Se) : HEX,  34 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 36, " Bromine      (Br) : ORC,  35 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 37, " Krypton      (Kr) : FCC,  36 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 38, " Rubidium     (Rb) : BCC,  37 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 39, " Strontium    (Sr) : FCC,  38 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 40, " Yttrium      ( Y) : HEX,  39 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 41, " Zirconium    (Zr) : HEX,  40 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 42, " Niobium      (Nb) : BCC,  41 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 43, " Molybdenum   (Mo) : BCC,  42 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 44, " Technetium   (Tc) : HEX,  43 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 45, " Ruthenium    (Ru) : HEX,  44 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 46, " Rhodium      (Rh) : FCC,  45 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 47, " Palladium    (Pd) : FCC,  46 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 48, " Silver       (Ag) : FCC,  47 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 49, " Cadmium      (Cd) : HEX,  48 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 50, " Indium       (In) : TET,  49 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 51, " Tin          (Sn) : TET,  50 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 52, " Antimony     (Sb) : RHL,  51 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 53, " Tellurium    (Te) : HEX,  52 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 54, " Iodine       ( I) : ORC,  53 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 55, " Xenon        (Xe) : FCC,  54 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 56, " Cesium       (Cs) : BCC,  55 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 57, " Barium       (Ba) : BCC,  56 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 58, " Lanthanum    (La) : HEX,  57 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 59, " Cerium       (Ce) : FCC,  58 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 60, " Praseodymium (Pr) : HEX,  59 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 61, " Neodymium    (Nd) : HEX,  60 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 62, " Promethium   (Pm) :       61 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 63, " Samarium     (Sm) : RHL,  62 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 64, " Europium     (Eu) : BCC,  63 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 65, " Gadolinium   (Gd) : HEX,  64 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 66, " Terbium      (Tb) : HEX,  65 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 67, " Dysprosium   (Dy) : HEX,  66 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 68, " Holmium      (Ho) : HEX,  67 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 69, " Erbium       (Er) : HEX,  68 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 70, " Thulium      (Tm) : HEX,  69 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 71, " Ytterbium    (Yb) : FCC,  70 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 72, " Lutetium     (Lu) : HEX,  71 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 73, " Hafnium      (Hf) : HEX,  72 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 74, " Tantalum     (Ta) : BCC,  73 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 75, " Tungsten     ( W) : BCC,  74 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 76, " Rhenium      (Re) : HEX,  75 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 77, " Osmium       (Os) : HEX,  76 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 78, " Iridium      (Ir) : FCC,  77 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 79, " Platinum     (Pt) : FCC,  78 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 80, " Gold         (Au) : FCC,  79 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 81, " Mercury      (Hg) : RHL,  80 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 82, " Thallium     (Tl) : HEX,  81 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 83, " Lead         (Pb) : FCC,  82 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 84, " Bismuth      (Bi) : RHL,  83 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 85, " Polonium     (Po) :  SC,  84 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 86, " Astatine     (At) :    ,  85 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 87, " Radon        (Rn) : FCC,  86 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 88, " Francium     (Fr) : BCC,  87 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 89, " Radium       (Ra) :    ,  88 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 90, " Actinium     (Ac) : FCC,  89 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 91, " Thorium      (Th) : FCC,  90 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 92, " Protactinium (Pa) : TET,  91 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 93, " Uranium      ( U) : ORC,  92 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 94, " Neptunium    (Np) : ORC,  93 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 95, " Plutonium    (Pu) : MCL,  94 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 96, " Americium    (Am) :    ,  95 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 97, " Curium       (Cm) :    ,  96 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 98, " Berkelium    (Bk) :    ,  97 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items, 99, " Californium  (Cf) :    ,  98 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,100, " Einsteinium  (Es) :    ,  99 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,101, " Fermium      (Fm) :    , 100 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,102, " Mendelevium  (Md) :    , 101 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,103, " Nobelium     (No) :    , 102 ", menu_Set_Current_Atom_Type);
			Init_VN_Menu_Entry(&Atom_Items,104, " Lawrencium   (Lw) :    , 103 ", menu_Set_Current_Atom_Type);

/* Orientation of the cell */
VN_Menu Axes_Items;
			if(Init_VN_Menu(&Axes_Items, "Main / Axis Menus", 2, 2) == VN_MENU_ERROR)
				{
					printf("\n Can not create Axis menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Axes_Items, 1," Make Cell", menu_axes_type);
			Init_VN_Menu_Entry(&Axes_Items, 2," Rotate Cell", menu_axes_type);


/* Select subsets for operations */
VN_Menu	Subset_Items;

/* Alloying element */
VN_Menu	Alloy_Items;
			if(Init_VN_Menu(&Alloy_Items, "Main / Alloy Menus", 2, 2 == VN_MENU_ERROR)
				{
					printf("\n Can not create Alloy menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Alloy_Items, 1," Random ", menu_alloy_random);
			Init_VN_Menu_Entry(&Alloy_Items, 2," Systematic ", menu_alloy_systematic);

/* Dislocation */
VN_Menu	Dislocation_Items;
			if(Init_VN_Menu(&Dislocation_Items, "Main / Dislocation Menus", 2, 2 == VN_MENU_ERROR)
				{
					printf("\n Can not create Dislocation menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Dislocation_Items, 1," Dislocation 1 ", menu_dislocation);
			Init_VN_Menu_Entry(&Dislocation_Items, 2," Dislocation 2 ", menu_dislocation);

/* Strain field */
VN_Menu	Strain_Items;
			if(Init_VN_Menu(&Strain_Items, "Main / Strain Menus", 2, 2 == VN_MENU_ERROR)
				{
					printf("\n Can not create Strain menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Strain_Items, 1," Tensile ", menu_tensile);
			Init_VN_Menu_Entry(&Strain_Items, 2," Shear ", menu_shear);

/* Volume displacement */
VN_Menu	Volume_Disp_Items;
			if(Init_VN_Menu(&Volume_Disp_Items, "Main / Volume Displacement Menus", 2, 2 == VN_MENU_ERROR)
				{
					printf("\n Can not create Volume Displacement menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Volume_Disp_Items, 1," Translational ", menu_translation);
			Init_VN_Menu_Entry(&Volume_Disp_Items, 2," Rotational ", menu_rotation);

/* Compute */
VN_Menu	Compute_Items;
			if(Init_VN_Menu(&Compute_Items, "Main / Compute Menus", 17, 17 == VN_MENU_ERROR)
				{
					printf("\n Can not create Compute menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Compute_Items, 1," Make the computational cell", menu_make_cell);
			Init_VN_Menu_Entry(&Compute_Items, 2," Assess Periodicity", menu_periodicity);
			Init_VN_Menu_Entry(&Compute_Items, 3," Heterojunction", menu_h_junction);
			Init_VN_Menu_Entry(&Compute_Items, 4," Keep atoms in subset only", menu_retain_subset);
			Init_VN_Menu_Entry(&Compute_Items, 5," Alloy", menu_alloy_make);
			Init_VN_Menu_Entry(&Compute_Items, 6," Dislocation", compute_dislocation);
			Init_VN_Menu_Entry(&Compute_Items, 7," Strain", menu_strain);
			Init_VN_Menu_Entry(&Compute_Items, 8," Translational Displacement", menu_rigid_displacement);
			Init_VN_Menu_Entry(&Compute_Items, 9," Energy", menu_energy );
			Init_VN_Menu_Entry(&Compute_Items,10," Rotate the cell", menu_rotate_cell);
			Init_VN_Menu_Entry(&Compute_Items,11," Relax the Cell", menu_relax);
			Init_VN_Menu_Entry(&Compute_Items,12," Grain Boundary", menu_GB);
			Init_VN_Menu_Entry(&Compute_Items,13," Extend cell along Z axis", menu_cell_extend);
			Init_VN_Menu_Entry(&Compute_Items,14," Adjust Bond Lengths", menu_bond);
			Init_VN_Menu_Entry(&Compute_Items,15," Adjust IAP Parameters", menu_IAP_Select);
			Init_VN_Menu_Entry(&Compute_Items,16," Edit atomic positions", menu_edit);
			Init_VN_Menu_Entry(&Compute_Items,17," Rotational displacement", menu_rotational_displacement);

/* Manin menu */
VN_Menu	Main_Items;
			if(Init_VN_Menu(&Main_Items, "Main Menu", 10, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Main_Items, 1," File Handler",menu_Main_File );
			Init_VN_Menu_Entry(&Main_Items, 2," Select Unit Cell", menu_Main_Unit_Cell);
			Init_VN_Menu_Entry(&Main_Items, 3," Select Atom", menu_Main_Atom);
			Init_VN_Menu_Entry(&Main_Items, 4," Define Miller Indices", menu_Main_MIndex);
			Init_VN_Menu_Entry(&Main_Items, 5," Define Subset", menu_Main_Subset);
			Init_VN_Menu_Entry(&Main_Items, 6," Specify the Alloy", menu_Main_Alloy);
			Init_VN_Menu_Entry(&Main_Items, 7," Disloation Parameters", menu_Main_Disloc);
			Init_VN_Menu_Entry(&Main_Items, 8," Strain Parameters", menu_Main_Strain);
			Init_VN_Menu_Entry(&Main_Items, 9," Rigid Displacement Values", menu_Main_Rigid_Disp);
			Init_VN_Menu_Entry(&Main_Items, 10," Make Computations", menu_Main_Compute);


	char user_institute[] = " ";

/* POPUP Menu under Energy command */
VN_Menu	Compute_Energy_Items;
			if(Init_VN_Menu(&Compute_Energy_Items, "Main / Compute / Energy  Menu", 2, 2) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Compute / Energy menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Compute_Energy_Items, 1," Boundaries",menu_boundaries );
			Init_VN_Menu_Entry(&Compute_Energy_Items, 2," Calculate",menu_compute_cell_energy );


/*  POPUP menu under the subset command */
VN_Menu Subset_Shape_Items;
			if(Init_VN_Menu(&Subset_Shape_Items, "Main / Subset / Shape  Menu", 5, 5) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Subset / Shape menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Subset_Shape_Items, 1," Entire cell ",menu_subset_shape );
			Init_VN_Menu_Entry(&Subset_Shape_Items, 2," Cubic",menu_subset_shape );
			Init_VN_Menu_Entry(&Subset_Shape_Items, 3," Cylindrical",menu_subset_shape );
			Init_VN_Menu_Entry(&Subset_Shape_Items, 4," Spherical",menu_subset_shape );
			Init_VN_Menu_Entry(&Subset_Shape_Items, 5," Slice",menu_subset_shape );

VN_Menu Subset_Shape_Size_Items;
			if(Init_VN_Menu(&Subset_Shape_Size_Items, "Main / Subset / Shape / Size  Menu", 5, 5) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Subset / Shape / Size menu");
					exit(0);
				}

	char subset_limit_entry[SUBSET_LIMIT_ENTRIES][30];
	char XYZ_Min_Max[SUBSET_LIMIT_ENTRIES][15] = {
	' ', ' ', ' ', ' ', 'X', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'X', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'Y', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'Y', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'Z', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'Z', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'R', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'R', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	'T', 'h', 'e', 't', 'a', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	'T', 'h', 'e', 't', 'a', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'Z', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'Z', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', ' ', 'X', '-', 'C', 'e', 'n', 't', 'e', 'r', ' ', '\0',
	' ', ' ', ' ', ' ', ' ', 'Y', '-', 'C', 'e', 'n', 't', 'e', 'r', ' ', '\0',
	' ', ' ', ' ', ' ', 'R', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', 'R', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	'T', 'h', 'e', 't', 'a', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	'T', 'h', 'e', 't', 'a', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', 'P', 'H', 'I', '-', 'M', 'i', 'n', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', 'P', 'H', 'I', '-', 'M', 'a', 'x', 'i', 'm', 'u', 'm', ' ', '\0',
	' ', ' ', ' ', ' ', ' ', 'X', '-', 'C', 'e', 'n', 't', 'e', 'r', ' ', '\0',
	' ', ' ', ' ', ' ', ' ', 'Y', '-', 'C', 'e', 'n', 't', 'e', 'r', ' ', '\0',
	' ', ' ', ' ', ' ', ' ', 'Z', '-', 'C', 'e', 'n', 't', 'e', 'r', ' ', '\0',
	' ', ' ', ' ', ' ', 'S', 'L', 'I', 'C', 'E', ' ', 'X', 'M', 'I', 'N', '\0',
	' ', ' ', ' ', ' ', 'S', 'L', 'I', 'C', 'E', ' ', 'X', 'M', 'A', 'X', '\0',
	' ', ' ', ' ', ' ', 'S', 'L', 'I', 'C', 'E', ' ', 'Y', 'M', 'I', 'N', '\0',
	' ', ' ', ' ', ' ', 'S', 'L', 'I', 'C', 'E', ' ', 'Y', 'M', 'A', 'X', '\0',
	' ', ' ', ' ', ' ', 'S', 'L', 'I', 'C', 'E', ' ', 'Z', 'M', 'I', 'N', '\0',
	' ', ' ', ' ', ' ', 'S', 'L', 'I', 'C', 'E', ' ', 'Z', 'M', 'A', 'X', '\0'
	 };

/* The strain menu	*/
	VN_Menu Strain_Size_Items;
			if(Init_VN_Menu(&Strain_Axis_Items, "Main / Strain /  Value  Menu", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Strain / Value menu");
					exit(0);
				}

	POPUP_MENU_ENTRY_PTR tensile_strain_menu_array;
	POPUP_MENU_PTR p_tensile_strain;
	char Tensile_Strain_Entry[STRAIN_ENTRIES][20];
	char Tensile_Strain[STRAIN_ENTRIES][9] = {
	'A', 'l', 'o', 'n', 'g', ' ', 'X', ' ', '\0',
	'A', 'l', 'o', 'n', 'g', ' ', 'Y', ' ', '\0',
	'A', 'l', 'o', 'n', 'g', ' ', 'Z', ' ', '\0'
	 };

/* The alloy : Random popup menu */
VN_Menu Alloy_Random_Items;
			if(Init_VN_Menu(&Alloy_Random_Items, "Main / Alloy / Random Menu", 2, 2) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Alloy / Random menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&Alloy_Random_Items, 1," Perc / Number of Alloy Atoms", Read_Perc_or_Number);
		Init_VN_Menu_Entry(&Alloy_Random_Items, 2," Select Alloying Element", Get_Random_Alloy_Element);


	POPUP_MENU_ENTRY_PTR Number_Percentage_menu_array;
	POPUP_MENU_PTR p_Number_Percentage;
	char Number_Percentage_Entry[2][30];
	char Number_Percentage[2][14] = {
	' ', ' ', ' ', ' ', 'N', 'u', 'm', 'b', 'e', 'r', ' ', ':', ' ', '\0',
	'P', 'e', 'r', 'c', 'e', 'n', 't', 'a', 'g', 'e', ' ', ':', ' ', '\0'
	};


	char user_id[] = " a single installation only. ";
/* The alloy : Systematic Popup Menu */

	POPUP_MENU_ENTRY_PTR alloy_systematic_menu_array;
	POPUP_MENU_PTR p_alloy_systematic;
	char Alloy_Systematic_Entry[ALLOY_ENTRIES][40];


/* POPUP menu to select elements for modifying the IAP parameters */
VN_Menu	IAP_Alloy_Element_Items;
		if(Init_VN_Menu(&IAP_Alloy_Element_Items, "Main/Alloy/Systematic/Element Menu", 104, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Alloy/Systematic/Element menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 1," Vacancy           ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 2," Hydrogen     ( H) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 3," Helium       (He) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 4," Lithium      (Li) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 5," Beryillium   (Be) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 6," Boron        ( B) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 7," Carbon       ( C) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 8," Nitrogen     ( N) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 9," Oxygen       ( O) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 10," Fluorine     ( F) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 11," Neon         (Ne) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 12," Sodium       (Na) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 13," Magnesium    (Mg) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 14," Aluminium    (Al) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 15," Silicon      (Si) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 16," Phosphorus   ( P) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 17," Sulfur       ( S) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 18," Chlorine     (Cl) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 19," Argon        (Ar) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 20," Potassium    ( K) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 21," Calcium      (Ca) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 22," Scandium     (Sc) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 23," Titanium     (Ti) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 24," Vanadium     ( V) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 25," Chromium     (Cr) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 26," Mangenese    (Mn) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 27," Iron         (Fe) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 28," Cobalt       (Co) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 29," Nickel       (Ni) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 30," Copper       (Cu) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 31," Zinc         (Zn) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 32," Gallium      (Ga) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 33," Germanium    (Ge) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 34," Arsenic      (As) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 35," Selenium     (Se) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 36," Bromine      (Br) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 37," Krypton      (Kr) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 38," Rubidium     (Rb) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 39," Strontium    (Sr) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 40," Yttrium      ( Y) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 41," Zirconium    (Zr) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 42," Niobium      (Nb) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 43," Molybdenum   (Mo) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 44," Technetium   (Tc) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 45," Ruthenium    (Ru) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 46," Rhodium      (Rh) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 47," Palladium    (Pd) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 48," Silver       (Ag) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 49," Cadmium      (Cd) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 50," Indium       (In) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 51," Tin          (Sn) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 52," Antimony     (Sb) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 53," Tellurium    (Te) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 54," Iodine       ( I) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 55," Xenon        (Xe) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 56," Cesium       (Cs) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 57," Barium       (Ba) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 58," Lanthanum    (La) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 59," Cerium       (Ce) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 60," Praseodymium (Pr) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 61," Neodymium    (Nd) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 62," Promethium   (Pm) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 63," Samarium     (Sm) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 64," Europium     (Eu) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 65," Gadolinium   (Gd) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 66," Terbium      (Tb) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 67," Dysprosium   (Dy) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 68," Holmium      (Ho) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 69," Erbium       (Er) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 70," Thulium      (Tm) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 71," Ytterbium    (Yb) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 72," Lutetium     (Lu) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 73," Hafnium      (Hf) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 74," Tantalum     (Ta) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 75," Tungsten     ( W) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 76," Rhenium      (Re) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 77," Osmium       (Os) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 78," Iridium      (Ir) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 79," Platinum     (Pt) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 80," Gold         (Au) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 81," Mercury      (Hg) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 82," Thallium     (Tl) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 83," Lead         (Pb) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 84," Bismuth      (Bi) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 85," Polonium     (Po) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 86," Astatine     (At) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 87," Radon        (Rn) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 88," Francium     (Fr) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 89," Radium       (Ra) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 90," Actinium     (Ac) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 91," Thorium      (Th) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 92," Protactinium (Pa) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 93," Uranium      ( U) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 94," Neptunium    (Np) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 95," Plutonium    (Pu) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 96," Americium    (Am) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 97," Curium       (Cm) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 98," Berkelium    (Bk) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items, 99," Californium  (Cf) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items,100," Einsteinium  (Es) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items,101," Fermium      (Fm) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items,102," Mendelevium  (Md) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items,103," Nobelium     (No) ", Set_IAP_Alloy_Element_Type);
		Init_VN_Menu_Entry(&IAP_Alloy_Element_Items,104," Lawrencium   (Lw) ", Set_IAP_Alloy_Element_Type);


	POPUP_MENU_ENTRY_PTR IAP_menu_array;
	POPUP_MENU_PTR p_IAP;

/*
	POPUP_MENU_ENTRY IAP_Menu_items[] = {
	" NULL Potential       ", 1, 0, 0, Set_IAP_Type,
	" Two Body             ", 2, 0, 0, Set_IAP_Type,
	" Two Body Alt.        ", 3, 0, 0, Set_IAP_Type,
	" Three Body           ", 4, 0, 0, Set_IAP_Type,
	CWL_NULL, 0};
	POPUP_MENU_PTR p_IAP;
*/

		char	param_name[IAP_ENTRIES][13];
		char	param_name_value[IAP_ENTRIES][30];
		POPUP_MENU_ENTRY_PTR IAP_Param_menu_array;
		POPUP_MENU_PTR p_IAP_Param_menu_array;


VN_Menu IAP_Modify;
		if(Init_VN_Menu(&IAP_Modify, "Main/Compute/IAP Menu", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Compute/IAP menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&IAP_Modify, 1," Read IAP parameters from a file", Read_IAP_Param_File);
		Init_VN_Menu_Entry(&IAP_Modify, 2," Modify current settings", Modify_IAP_Param);
		Init_VN_Menu_Entry(&IAP_Modify, 3," Save IAP parameters to a file", Save_IAP_Param_File);


/*  POPUP menu to select atomic positions of the user defined unit cell */

	VN_Menu *User_Unit_Cell;
	char Unit_Cell_Entry[MAX_UNIT_CELL_ATOMS][40];



/*  POPUP menu to select the relaxation parameters */

	POPUP_MENU_ENTRY_PTR relax_menu_array;
	POPUP_MENU_PTR p_relax;
	char Relax_Entry[RELAX_ENTRIES][33];
	char Relax_Phrases[RELAX_ENTRIES][20] = {
	' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', 'D', 'e', 'l', 't', 'a', ' ', 'R', ':', '\0',
	' ', ' ', ' ', ' ', ' ', ' ', 'D', 'e', 'l', 't', 'a', ' ', 'E', 'n', 'e', 'r', 'g', 'y', ':', '\0',
	' ', ' ', ' ', ' ', 'M', 'a', 'x', ' ', 'I', 't', 'e', 'r', 'a', 't', 'i', 'o', 'n', 's', ':', '\0',
	'R', 'e', 'l', 'a', 'x', ' ', ':', 'S', 't', 'a', 't', 'i', 'c', ' ', ' ', ' ', ' ', ' ', ' ', '\0',
	' ', ' ', ' ', ' ', 'T', 'e', 'm', 'p', 'e', 'r', 'a', 't', 'u', 'r', 'e', '(', 'K', ')', ':', '\0',
	' ', ' ', ' ', ' ', ' ', ' ', 'E', 'n', 'e', 'r', 'g', 'y', ' ', 'P', 'l', 'o', 't', ' ', ' ', '\0',
	'R', 'e', 'l', 'a', 'x', ' ', ':', ' ', 'M', 'o', 'n', 't', 'e', '-', 'C', 'a', 'r', 'l', 'o', '\0',
	' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', 'M', 'C', ' ', 'B', 'i', 'a', 's', ':', '\0',
	'R', 'e', 'l', 'a', 'x', ' ', ':', ' ', 'S', 'i', 'm', ' ', 'A', 'n', 'n', 'e', 'a', 'l', ' ', '\0',
	' ', 'T', 'e', 'm', 'p', 'e', 'r', 'a', 't', 'u', 'r', 'e', ' ', 'S', 't', 'e', 'p', ' ', ':', '\0',
	' ', 'F', 'i', 'n', 'a', 'l', ' ', 'T', 'e', 'm', 'p', 'e', 'r', 'a', 't', 'u', 'r', 'e', ':', '\0',
	'R', 'e', 'l', 'a', 'x', ' ', ':', 'A', 't', 'o', 'm', ' ', 'S', 'w', 'a', 'p', ':', ' ', ' ', '\0',
	'S', 'w', 'a', 'p', ' ', ' ', 'R', 'e', 'l', 'a', 'x', ' ', 'S', 'p', 'h', 'e', 'r', 'e', ':', '\0',
	' ', 'N', 'e', 'a', 'r', 'e', 's', 't', ' ', 'N', 'e', 'b', ' ', 'D', 'i', 's', 't', ' ', ':', '\0',
	'R', 'e', 'l', 'a', 'x', ' ', ':', 'A', 't', 'o', 'm', ' ', 'W', 'a', 'l', 'k', ':', ' ', ' ', '\0'
	};

	POPUP_MENU_ENTRY_PTR mc_plot_menu_array;
	POPUP_MENU_PTR p_mc_plot;
	char MC_Plot_Entry[MC_PLOT_ENTRIES][20];
	char MC_Plot_Phrases[MC_PLOT_ENTRIES][8] = {
	'X', 'M', 'I', 'N', ' ', ':', ' ', '\0',
	'X', 'M', 'A', 'X', ' ', ':', ' ', '\0',
	'Y', 'M', 'I', 'N', ' ', ':', ' ', '\0',
	'Y', 'M', 'A', 'X', ' ', ':', ' ', '\0',
	'P', 'L', 'O', 'T', ' ', ':', ' ', '\0'
	};

/*  POPUP menu to select the bond adjustment parameters */

	POPUP_MENU_ENTRY_PTR bond_menu_array;
	POPUP_MENU_PTR p_bond;
	char Bond_Entry[BOND_ENTRIES][30];
	float Delta_R, Delta_Energy;
	int Iterations;
	char Bond_Phrases[BOND_ENTRIES][16] = {
	' ', ' ', ' ', ' ', ' ', ' ', ' ', 'D', 'e', 'l', 't', 'a', ' ', 'R', ' ', '\0',
	'%', 'C', 'h', 'a', 'n', 'g', 'e', ' ', 'F', 'r', 'o', 'm', ' ', 'R', '0', '\0',
	'M', 'a', 'x', ' ', 'I', 't', 'e', 'r', 'a', 't', 'i', 'o', 'n', 's', ' ', '\0',
	' ', ' ', ' ', ' ', ' ', ' ', ' ', 'R', 'e', 'l', 'a', 'x', '.', '.', '.', '\0'
	};



/*  POPUP menu to select the Grain Boundary parameters */

	POPUP_MENU_ENTRY_PTR GB_menu_array;
	POPUP_MENU_PTR p_GB;
	char GB_Entry[GB_ENTRIES][30];
	char GB_Phrases[GB_ENTRIES][18] = {
	' ', ' ', ' ', ' ', ' ', ' ', ' ', 'G', 'B', ' ', 'A', 'n', 'g', 'l', 'e', ' ', ':', '\0',
	'C', 'o', 'r', 'e', ' ', 'W', 'i', 'd', 't', 'h', ' ', '(', 'A', ')', ' ', ':', ' ', '\0',
	' ', ' ', ' ', ' ', 'M', 'a', 'k', 'e', ' ', 'B', 'o', 'u', 'n', 'd', 'a', 'r', 'y', '\0',
	' ', ' ', ' ', 'C', 'o', 'n', 's', 't', 'r', 'u', 'c', 't', ' ', 'C', 'o', 'r', 'e', '\0',
	};



/*  POPUP menu to select the plot orientation */
VN_Menu	View_Orient;
		if(Init_VN_Menu(&View_Orient, "Main/View Menu", 2, 2) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/View menu");
					exit(0);
				}

		Init_VN_Menu_Entry(&View_Orient, 1," Y vs X", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 2," Z vs X", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 3," Y vs Z", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 4," Color code planes", menu_plane_or_atom);
		Init_VN_Menu_Entry(&View_Orient, 5," Color code atoms", menu_plane_or_atom);


/* Menu for inputing the axes */

	VN_Menu	Cell_Axis;
	char axes_entry[3][20];

/* Boundary Menu */

	POPUP_MENU_ENTRY_PTR boundary_menu_array;
	POPUP_MENU_PTR p_boundary;
	char Boundary_Menu_Entry[BOUNDARY_PARAM][30];
	char Selected_Axis;

VN_Menu	Boundary_Type;
		if(Init_VN_Menu(&Boundary_Type, "Main/Compute/Energy Menu", 2, 2) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Compute/Energy menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&Boundary_Type, 1," Non Periodic", set_boundary);
		Init_VN_Menu_Entry(&Boundary_Type, 2,"   Periodic", set_boundary);

/* Menu for setting dislocation settings */

	POPUP_MENU_ENTRY_PTR dislocation_menu_array;
	POPUP_MENU_PTR p_dislocation;
	char Dislocation_Menu_Entry[DISLOCATION_PARAM][35];
	char Dislocation_Entry[DISLOCATION_PARAM][20] = {
	'T', 'y', 'p', 'e', ' ', ':', ' ', '\0', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
	'X', ' ', '=', ' ', '\0', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
	'Y', ' ', '=', ' ', '\0', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
	'B', 'u', 'r', 'g', 'e', 'r', '\'', 's', ' ', 'V', 'e', 'c', 't', 'o', 'r', '\0', ' ', ' ', ' ', ' ',
	'O', 'r', 'i', 'e', 'n', 't', 'a', 't', 'i', 'o', 'n', ' ', ':', '\0', ' ', ' ', ' ', ' ', ' ', ' ',
	'D', 'i', 's', 'l', 'o', 'c', 'a', 't', 'i', 'o', 'n', ' ', 'L', 'i', 'n', 'e', ' ', ':', ' ', '\0'
	 };

VN_Menu	Dislocation_Type;
		if(Init_VN_Menu(&Dislocation_Type, "Main/Dislocation/1_or_2/Type Menu", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Dislocation/1_or_2/Type menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&Dislocation_Type, 1," Null", get_dislocation_type);
		Init_VN_Menu_Entry(&Dislocation_Type, 2," Edge", get_dislocation_type);
		Init_VN_Menu_Entry(&Dislocation_Type, 3," Screw", get_dislocation_type);

	char D_Type[3][10] = {
	'N', 'u', 'l', 'l', '\0', ' ', ' ', ' ', ' ', ' ',
	'E', 'd', 'g', 'e', ' ', '\0', ' ', ' ', ' ', ' ',
	'S', 'c', 'r', 'e', 'w', '\0', ' ', ' ', ' ', ' ',
	};

VN_Menu	Dislocation_Orientation;
		if(Init_VN_Menu(&Dislocation_Orientation, "Main/Dislocation/1_or_2/Orient Menu", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Dislocation/1_or_2/Orient menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&Dislocation_Orientation, 1," -ve", get_dislocation_orientation);
		Init_VN_Menu_Entry(&Dislocation_Orientation, 2," +ve", get_dislocation_orientation);
	char D_Orientation[2][4] = {
	'-', 'v', 'e', '\0',
	'+', 'v', 'e', '\0'
	};


VN_Menu	Dislocation_Line;
		if(Init_VN_Menu(&Dislocation_Line, "Main/Dislocation/1_or_2/Line Menu", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Dislocation/1_or_2/Line menu");
					exit(0);
				}
		Init_VN_Menu_Entry(&Dislocation_Line, 1,"Along : Z", get_dislocation_line);
		Init_VN_Menu_Entry(&Dislocation_Line, 2,"Along : Y", get_dislocation_line);
		Init_VN_Menu_Entry(&Dislocation_Line, 3,"Along : X", get_dislocation_line);
	char D_Line[3][2] = {
	'Z', '\0',
	'Y', '\0',
	'X', '\0'
	};

VN_Menu	Displacement_Trans;
		if(Init_VN_Menu(&Displacement_Trans, "Main/Rigid_Displ/Translation", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Rigid_Disp/Translational menu");
					exit(0);
				}

	char Translation_Menu_Entry[TRANSLATION_PARAM][20];
	char Translation_Entry[TRANSLATION_PARAM][10] = {
	'A', 'l', 'o', 'n', 'g', ' ', 'X', ' ', ':', '\0',
	'A', 'l', 'o', 'n', 'g', ' ', 'Y', ' ', ':', '\0',
	'A', 'l', 'o', 'n', 'g', ' ', 'Z', ' ', ':', '\0'
	};

VN_Menu	Displacement_Rotate;
		if(Init_VN_Menu(&Displacement_Rotate, "Main/Rigid_Displ/Rotate", 3, 3) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Rigid_Disp/Rotate menu");
					exit(0);
				}

	char Rotation_Menu_Entry[ROTATION_PARAM][25];
	char Rotation_Entry[ROTATION_PARAM][11] = {
	'A', 'r', 'o', 'u', 'n', 'd ', ' ', 'X', ' ', ':', '\0',
	'A', 'r', 'o', 'u', 'n', 'd ', ' ', 'Y', ' ', ':', '\0',
	'A', 'r', 'o', 'u', 'n', 'd ', ' ', 'Z', ' ', ':', '\0'
	};


char user_name[] = "For a single installation only. ";

main()
{
	int i,d;
			Initialize_ADESH();
			show_user();
			if(Init_VN_Menu(&Main_Items, "Main Menu", 10, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Main_Items, 1," File Handler",menu_Main_File );
			Init_VN_Menu_Entry(&Main_Items, 2," Select Unit Cell", menu_Main_Unit_Cell);
			Init_VN_Menu_Entry(&Main_Items, 3," Select Atom", menu_Main_Atom);
			Init_VN_Menu_Entry(&Main_Items, 4," Define Miller Indices", menu_Main_MIndex);
			Init_VN_Menu_Entry(&Main_Items, 5," Define Subset", menu_Main_Subset);
			Init_VN_Menu_Entry(&Main_Items, 6," Specify the Alloy", menu_Main_Alloy);
			Init_VN_Menu_Entry(&Main_Items, 7," Disloation Parameters", menu_Main_Disloc);
			Init_VN_Menu_Entry(&Main_Items, 8," Strain Parameters", menu_Main_Strain);
			Init_VN_Menu_Entry(&Main_Items, 9," Rigid Displacement Values", menu_Main_Rigid_Disp);
			Init_VN_Menu_Entry(&Main_Items, 10," Make Computations", menu_Main_Compute);

			while(1)
				{
						/* get the menu options */
					Handle_Menu(&Main_Items, 1);
				}
							/* dispose of menu */
			Close_VN_Menu(&Main_Items);
			return (0);
}




int menu_read_file(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		Read_CC();
		return(VN_MENU_EXIT);
	}

int menu_save_cell(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		Save_CC(CURRENT_FILE);
		return(VN_MENU_EXIT);
	}


int menu_save_as_cell(VN_Menu *VN_Menu_Name, int VN_Menu_Entry))
 {
		Save_CC(USER_DEFINED_FILE);
		return(VN_MENU_EXIT);
 }


int menu_list_file(VN_Menu *VN_Menu_Name, int VN_Menu_Entry))
 {
	List_CC();
	return(VN_MENU_EXIT);
 }

int menu_print(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		Print_CC();
		return(VN_MENU_EXIT);
	}


int menu_select_and_view(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int	i;
	VN_Menu	View_Orient;
		if(Init_VN_Menu(&View_Orient, "Main/View Menu", 2, 2) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/View menu");
					exit(0);
				}

		Init_VN_Menu_Entry(&View_Orient, 1," Y vs X", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 2," Z vs X", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 3," Y vs Z", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 4," Color code planes", menu_plane_or_atom);
		Init_VN_Menu_Entry(&View_Orient, 5," Color code atoms", menu_plane_or_atom);
		Handle_Menu(&View_Orient, 1);
		Close_VN_Menu(&View_Orient);
	return(PULLDOWN_EXIT);
 }


int menu_view_type(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	Selected_Plot_Type = VN_Menu_Entry - 1;
	View_CC();
	return(POPUP_EXIT);
 }

int menu_plane_or_atom(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	Plot_Color_Code = (int)VN_Menu_Entry - 4;
	return(POPUP_CONTINUE);
 }


int menu_EXIT(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		 int i;
		 FILE *fp;

 /* dispose of menu */

			if(DEMO == DESH_YES)
				{
		VN_New_Screen();
		printf("  A file created/read & modified is saved automatically.");
		printf("\n  This feature is available in registered version.");
		printf("\n  Hit any key to continue ...");
		i=getch();
		exit(0);
				}

		if(File_Modification == DESH_NO)
			{
				VN_New_Screen();
				printf("\n  That's all Folks ....");
				i=getch();
				exit(0);
			}


		VN_New_Screen();
		printf("Data not saved. Save it (Y/N) ? ");
		i=0;
		while((i != 'N') && (i != 'n') && (i != 'Y') && (i != 'y') && (i != 27))
		{
		 i=getch();
		}
		if(i == 27)			/* Escape key pressed */
			return(VN_MENU_EXIT);

		if((i == 'y') || (i == 'Y'))
			{
				if(open_file_name[0] == '\0')
					{
						if(Save_CC(USER_DEFINED_FILE) == DESH_NO)
							{
								return(VN_MENU_EXIT);
							}
					}
				else
					{
						if(Save_CC(CURRENT_FILE) == DESH_NO)
							{
								return(VN_MENU_EXIT);
							}
					}
			}
		printf(pw,"\n That's all folks ....\n\n Hit any key to exit");
		i=getch();
		exit(0);
 }



int menu_Set_current_Cell_Type(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	Current_Cell_Type=VN_Menu_Entry-1;
	return(VN_MENU_EXIT);
 }


int menu_Define_User_Unit_Cell(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		int i,j;

		if(Init_VN_Menu(&File_Items, "Main / Unit Cell / User Defined", MAX_UNIT_CELL_ATOMS, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not Main/Unit Cell/User Defined menu");
					exit(0);
				}
		Current_Cell_Type=VN_Menu_Entry-1;
		Init_VN_Menu_Entry(&User_Unit_Cell, i+1, Unit_Cell_Entry[i],input_unit_cell_position);
		for(i=0; i<MAX_UNIT_CELL_ATOMS; i++)
			{
				format_unit_cell_entry(i, Unit_Cell_Entry[i]);
				Init_VN_Menu_Entry(&User_Unit_Cell, i+1, Unit_Cell_Entry[i],input_unit_cell_position);
			}
		Handle_VN_Menu(&User_Unit_Cell, 1);
		Close_VN_Menu(&User_Unit_Cell);
		PopupDeallocate( Unit_Cell_array);

/* Now use only the valid positions */

		i=0;	j=0;
		for(i=0; i<MAX_UNIT_CELL_ATOMS; i++)
			{
				if((Unit_Cell_Atoms[USER_UC].U_Cell[i][0] < 0 ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][0] >= 1. ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] < 0 ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] >= 1. ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] < 0 ) ||
					(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] >= 1. ))
						{
							Unit_Cell_Atoms[USER_UC].U_Cell[i][0] = -1.;
							Unit_Cell_Atoms[USER_UC].U_Cell[i][1] = -1.;
							Unit_Cell_Atoms[USER_UC].U_Cell[i][2] = -1.;
						}
				else
					{
						Unit_Cell_Atoms[USER_UC].U_Cell[j][0] =
								Unit_Cell_Atoms[USER_UC].U_Cell[i][0];
						Unit_Cell_Atoms[USER_UC].U_Cell[j][1] =
								Unit_Cell_Atoms[USER_UC].U_Cell[i][1];
						Unit_Cell_Atoms[USER_UC].U_Cell[j][2] =
								Unit_Cell_Atoms[USER_UC].U_Cell[i][2];
						if(i != j)
							{
								Unit_Cell_Atoms[USER_UC].U_Cell[i][0] = -1.;
								Unit_Cell_Atoms[USER_UC].U_Cell[i][1] = -1.;
								Unit_Cell_Atoms[USER_UC].U_Cell[i][2] = -1.;
							}
						j++;
					}
			}
		if(j == 0)
			{
				Unit_Cell_Atoms[USER_UC].U_Cell[0][0] = 0.;
				Unit_Cell_Atoms[USER_UC].U_Cell[0][1] = 0.;
				Unit_Cell_Atoms[USER_UC].U_Cell[0][2] = 0.;
				Unit_Cell_Atoms[USER_UC].No_of_U_Cell_Atoms=1;
			}
		else
			Unit_Cell_Atoms[USER_UC].No_of_U_Cell_Atoms=j;

		return(VN_MENU_EXIT);
	}


int input_unit_cell_position(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
	int i, j;
	char temp[50];
	float a;

		j=VN_Menu_Entry-1;
		i=0;
		VN_New_Screen();
		while(i<3)
		{
		 a=Unit_Cell_Atoms[USER_UC].U_Cell[j][i];
		 printf("\nAlong %c : ", XYZ[i]);
		 a=get_float(a);
		 Unit_Cell_Atoms[USER_UC].U_Cell[j][i] = a;
		 i++;
		}
		format_unit_cell_entry(j, temp);
		Change_VN_Menu_Entry(&VN_Menu_Name, VN_Menu_Entry, temp);
		return(VN_MENU_CONTINUE);
 }



void	format_unit_cell_entry(int i, char *c_string)
	{
		int j,k,l;
		char temp1[50];
		char temp[50];

		if((Unit_Cell_Atoms[USER_UC].U_Cell[i][0] < 0 ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][0] >= 1. ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] < 0 ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][1] >= 1. ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] < 0 ) ||
			(Unit_Cell_Atoms[USER_UC].U_Cell[i][2] >= 1. ))
				{
					sprintf(temp1, "Position %2d :      ,      ,       ",i+1);
				}
			else
				{
					sprintf(temp1, "Position %2d : ", i+1);
					for(l=0; l<3; l++)
						{
							decimal_to_fract(&j, &k,
								Unit_Cell_Atoms[USER_UC].U_Cell[i][l]);
							if(j == 0)
								sprintf(temp, "  0  ");
							else
								{
									if(k<10)
										sprintf(temp, "%2d/%1d ", j,k);
									else
										sprintf(temp, "%2d/%2d ", j,k);
								}
							if(l != 2)
								strcat(temp, ", ");
							strcat(temp1, temp);
						}
				}
			strcpy(c_string, temp1);
	}



int menu_Set_Current_Atom_Type(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int i,j;
	Current_Atom_Type=VN_Menu_Entry-1;
	for(i=0; i<UNIT_CELL_TYPES; i++)
		{
			 for(j=0; j< Unit_Cell_Atoms[i].No_of_U_Cell_Atoms; j++)
				{
					Unit_Cell_Atoms[i].U_Cell[j][3]=Current_Atom_Type;
				}
		}
	Lattice_D[0]=Element[Current_Atom_Type].Lattice_A;
	Lattice_D[1]=Element[Current_Atom_Type].Lattice_B;
	Lattice_D[2]=Element[Current_Atom_Type].Lattice_C;

	return(VN_MENU_EXIT);
 }



int menu_axes_type(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int i,j, k1, k2, k3;
	float a;
	float a1, a2, a3;
	char temp[50];
  VN_New_Screen();
	printf("Current axes are : ");
	i=0;
	while(i<3)
	{
	 printf("\n%c : ",XYZ[i]);
	 for(j=0; j<3; j++)
		{
		printf("%2.1d",current_axes[j][i]);
		if(j<2)
		 printf(",");
		}
	 i++;
	}

		if(Init_VN_Menu(&Cell_Axis, "Main / Miller_Indices / Axis Menu", MAX_UNIT_CELL_ATOMS, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not Main/ Miller Indices / Axis menu");
					exit(0);
				}

	if(VN_Menu_Entry == 1)
	 {
		i=0;
		while(i<3)
		 {
			for(j=0; j<3; axes[j][i] = new_axes[j][i], j++);
			sprintf(axes_entry[i], " %c  %3.1d,%3.1d,%3.1d",XYZ[i],axes[0][i],
							 axes[1][i],axes[2][i]);
			Init_VN_Menu_Entry(Cell_Axis, i+1, axes_entry[i], input_axes);
			i++;
		 }
	}
	else
	 {
		i=0;
		while(i<3)
		 {
			for(j=0; j<3; axes[j][i] = rotate_axes[j][i], j++);
			sprintf(axes_entry[i], " %c  %3.1d,%3.1d,%3.1d",XYZ[i],axes[0][i],
							 axes[1][i],axes[2][i]);
			Init_VN_Menu_Entry(Cell_Axis, i+1, axes_entry[i], input_axes);
			i++;
		 }
	 }
	 Handle_VN_Menu(&Cell_Axis, 1);
	 Close_VN_Menu(&Cell_Axis);

	 k1=0;	k2=0;	k3=0;
	 a1=0.;	a2=0.;	a3=0.;

	 for(i=0; i<3; k1=k1+axes[i][0]*axes[i][1], i++);
	 for(i=0; i<3; k2=k2+axes[i][0]*axes[i][2], i++);
	 for(i=0; i<3; k2=k2+axes[i][1]*axes[i][2], i++);
	 for(i=0; i<3; a1=a1+axes[i][0]*axes[i][0], i++);
	 for(i=0; i<3; a2=a2+axes[i][1]*axes[i][1], i++);
	 for(i=0; i<3; a2=a2+axes[i][2]*axes[i][2], i++);

	if((k1 == 0) && (k2 == 0) && (k3 == 0) &&
			(a1 >= 0.) && (a2 >= 0.) && (a3 >= 0.))
		{
		 if(vs == 1)
	 {
		i=0;
		while(i<3)
		 {
			a=0.;
			for(j=0; j<3; a=a+axes[j][i]*axes[j][i], j++);
			a=(float)sqrt((double)a);
			for(j=0; j<3; j++)
			 {
				new_axes[j][i] = axes[j][i];
				new_basis_vector[j][i] = (float)axes[j][i]/a;
			 }
			i++;
		 }
		i=matrix_inverse(new_basis_vector,f_make);
	 }
		if(vs == 2)
	 {
		i=0;
		while(i<3)
		 {
			a=0.;
			for(j=0; j<3; a=a+axes[j][i]*axes[j][i], j++);
			a=(float)sqrt((double)a);
			for(j=0; j<3; j++)
			 {
				rotate_axes[j][i] = axes[j][i];
				rotate_basis_vector[j][i] = (float)axes[j][i]/a;
			 }
			i++;
		 }
		matrix_inverse(rotate_basis_vector,rotate_axes_inverse);
		matrix_mult(rotate_axes_inverse,current_basis_vector,f_rotate);
	 }
		 return(VN_MENU_EXIT);
	 }
	 else
		{
			VN_New_Screen();
		 printf("The specified axes are not orthogonal \n");
		 printf("Dot Products : i.j = %d\n",k1);
		 printf("               i.k = %d\n",k2);
		 printf("               j.k = %d\n",k3);
		 printf("  Hit any key to continue ...");
		 i=getch();
		 return(VN_MENU_CONTINUE);
		}
	}


int input_axes(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int i;
	char temp[50];
		 VN_New_Screen();
		 i=0;
		 while(i<3)
			{
			 printf("\nAxis[%d][%d] = ",i+1,VN_Menu_Entry);
			 axes[i][VN_Menu_Entry-1] = get_integer(axes[i][VN_Menu_Entry-1]);
			 i++;
			}
		 i=VN_Menu_Entry-1;
		 sprintf(temp, " %c  %3.1d,%3.1d,%3.1d",XYZ[i],axes[0][i],
							 axes[1][i],axes[2][i]);
		 Change_Menu_Entry(VN_Menu_Name, VN_Menu_Entry, temp);
		 return(VN_MENU_CONTINUE);
 }


int menu_subset(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)

 {
	int	i;
	i=0;
	Selected_Subset_Type=VN_Menu_Entry-1;
			if(Init_VN_Menu(&Subset_Items, "Main / Subset Menus", 13, 13 == VN_MENU_ERROR)
				{
					printf("\n Can not create Subset menu");
					exit(0);
				}
			Init_VN_Menu_Entry(&Subset_Items, 1," Cell size in Angstroms ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 2," Hetero-structure       ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 3," Retain atoms within    ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 4," Strain                 ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 5," Alloy                  ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 6," Translational Disp     ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 7," Energy                 ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 8," Plot                   ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items, 9," RelaX : Static, MC, SA ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items,10," Bond Lengths           ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items,11," eDit atom positions    ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items,12," Rotational Disp        ", menu_subset);
			Init_VN_Menu_Entry(&Subset_Items,13," Relax : sWapping atoms ", menu_subset);

	Handle_VN_Menu(Subset_Items, 1);
	Close_VN_Menu(Subset_Items);
	return(VN_Menu_EXIT);
 }


int menu_subset_shape(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int i;
	float x_min, x_max, y_min, y_max, z_min, z_max;

			if(Init_VN_Menu(&Subset_Shape_Size_Items, "Main / Subset / Shape / Size  Menu", SUBSET_LIMIT_ENTRIES, 10) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Subset / Shape / Size menu");
					exit(0);
				}


	VN_New_Screen();
	if(((Selected_Subset_Type == CELL_SIZE) &&
		((VN_Menu_Entry-1 == ENTIRE_CELL) || (VN_Menu_Entry-1 == SLICE))) ||
		 ((VN_Menu_Entry-1 == SLICE) && (Selected_Subset_Type != PLOT)))

	{
		printf("\n  Illegal selection.\n  Hit any key to continue ...");
			i=getch();
		return(VN_MENU_EXIT);
	 }


	if(VN_Menu_Entry-1 == ENTIRE_CELL)
	 {
		subset[Selected_Subset_Type].TYPE=VN_Menu_Entry-1;
		if(Total_Atoms <= 0)
		 {
			printf("\n  No atoms in the cell ");
			printf("\n  Hit any key to continue .....");
			i=getch();
			return(VN_MENU_EXIT);
		 }

	 atom_ptr=atom_ptr_temp;
	 x_min=10000.;	y_min=10000.;	z_min=10000.;
		x_max=-10000.;	y_max=-10000;	z_max=-10000.;
		i=0;
	 while(i<Total_Atoms)
		 {
			if(atom_ptr->XC > x_max)
		 x_max=atom_ptr->XC;
			if(atom_ptr->YC > y_max)
			 y_max=atom_ptr->YC;
			if(atom_ptr->ZC > z_max)
			 z_max=atom_ptr->ZC;
			if(atom_ptr->XC < x_min)
			 x_min=atom_ptr->XC;
		if(atom_ptr->YC < y_min)
			 y_min=atom_ptr->YC;
			if(atom_ptr->ZC < z_min)
		 z_min=atom_ptr->ZC;
			i++;
			atom_ptr++;
		}
	 x_min=(float)((int)(x_min-1.5));
		x_max=(float)((int)(x_max+1.5));
		y_min=(float)((int)(y_min-1.5));
	 y_max=(float)((int)(y_max+1.5));
		z_min=(float)((int)(z_min-1.5));
		z_max=(float)((int)(z_max+1.5));
	 subset[Selected_Subset_Type].XMIN=x_min;
		subset[Selected_Subset_Type].XMAX=x_max;
		subset[Selected_Subset_Type].YMIN=y_min;
		subset[Selected_Subset_Type].YMAX=y_max;
		subset[Selected_Subset_Type].ZMIN=z_min;
		subset[Selected_Subset_Type].ZMAX=z_max;

		VN_New_Screen();
		printf("Limits are   Minumum    Maximum\n");
		printf(" Along  X    %6.2f     %6.2f\n",x_min,x_max);
		printf("        Y    %6.2f     %6.2f\n",y_min,y_max);
		printf("        Z    %6.2f     %6.2f\n",z_min,z_max);
		printf("     Hit any key to continue .....");

	 }
	else
	{
		if((VN_Menu_Entry-1 == CUBIC) || (VN_Menu_Entry-1 == SLICE) ||
			 (VN_Menu_Entry-1 == SPHERICAL) || (VN_Menu_Entry -1 == CYLINDRICAL))
		{
	subset[Selected_Subset_Type].TYPE=VN_Menu_Entry-1;
VN_Menu Subset_Shape_Size_Items;
			if(Init_VN_Menu(&Subset_Shape_Size_Items, "Main / Subset / Shape / Size  Menu", 5, 5) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main / Subset / Shape / Size menu");
					exit(0);
				}

	char subset_limit_entry[SUBSET_LIMIT_ENTRIES][30];
	char XYZ_Min_Max[SUBSET_LIMIT_ENTRIES][15] = {


	sprintf(subset_limit_entry[0], "%s   %6.2f", XYZ_Min_Max[0],
		 subset[Selected_Subset_Type].XMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 1, subset_limit_entry[0], input_subset_limit);

	sprintf(subset_limit_entry[1], "%s   %6.2f", XYZ_Min_Max[1],
		 subset[Selected_Subset_Type].XMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 2, subset_limit_entry[1], input_subset_limit);

	sprintf(subset_limit_entry[2], "%s   %6.2f", XYZ_Min_Max[2],
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 3, subset_limit_entry[2], input_subset_limit);
		 subset[Selected_Subset_Type].YMIN);

	sprintf(subset_limit_entry[3], "%s   %6.2f", XYZ_Min_Max[3],
		 subset[Selected_Subset_Type].YMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 4, subset_limit_entry[3], input_subset_limit);

	sprintf(subset_limit_entry[4], "%s   %6.2f", XYZ_Min_Max[4],
		 subset[Selected_Subset_Type].ZMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 5, subset_limit_entry[4], input_subset_limit);

	sprintf(subset_limit_entry[5], "%s   %6.2f", XYZ_Min_Max[5],
		 subset[Selected_Subset_Type].ZMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 6, subset_limit_entry[5], input_subset_limit);

	sprintf(subset_limit_entry[6], "%s   %6.2f", XYZ_Min_Max[6],
		 subset[Selected_Subset_Type].C_RMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 7, subset_limit_entry[6], input_subset_limit);

	sprintf(subset_limit_entry[7], "%s   %6.2f", XYZ_Min_Max[7],
		 subset[Selected_Subset_Type].C_RMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 8, subset_limit_entry[7], input_subset_limit);

	sprintf(subset_limit_entry[8], "%s   %6.2f PI", XYZ_Min_Max[8],
		 subset[Selected_Subset_Type].C_THETA_MIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 9, subset_limit_entry[8], input_subset_limit);

	sprintf(subset_limit_entry[9], "%s   %6.2f PI", XYZ_Min_Max[9],
		 subset[Selected_Subset_Type].C_THETA_MAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 10, subset_limit_entry[9], input_subset_limit);

	sprintf(subset_limit_entry[10], "%s   %6.2f", XYZ_Min_Max[10],
		 subset[Selected_Subset_Type].C_ZMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 11, subset_limit_entry[10], input_subset_limit);

	sprintf(subset_limit_entry[11], "%s   %6.2f", XYZ_Min_Max[11],
		 subset[Selected_Subset_Type].C_ZMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 12, subset_limit_entry[11], input_subset_limit);

	sprintf(subset_limit_entry[12], "%s   %6.2f", XYZ_Min_Max[12],
		 subset[Selected_Subset_Type].C_X_CENTER);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 13, subset_limit_entry[12], input_subset_limit);

	sprintf(subset_limit_entry[13], "%s   %6.2f", XYZ_Min_Max[13],
		 subset[Selected_Subset_Type].C_Y_CENTER);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 14, subset_limit_entry[13], input_subset_limit);


	sprintf(subset_limit_entry[14], "%s   %6.2f", XYZ_Min_Max[14],
		 subset[Selected_Subset_Type].SP_RMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 15, subset_limit_entry[14], input_subset_limit);

	sprintf(subset_limit_entry[15], "%s   %6.2f", XYZ_Min_Max[15],
		 subset[Selected_Subset_Type].SP_RMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 16, subset_limit_entry[15], input_subset_limit);

	sprintf(subset_limit_entry[16], "%s   %6.2f PI", XYZ_Min_Max[16],
		 subset[Selected_Subset_Type].SP_THETA_MIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 17, subset_limit_entry[16], input_subset_limit);

	sprintf(subset_limit_entry[17], "%s   %6.2f PI", XYZ_Min_Max[17],
		 subset[Selected_Subset_Type].SP_THETA_MAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 18, subset_limit_entry[17], input_subset_limit);

	sprintf(subset_limit_entry[18], "%s   %6.2f PI", XYZ_Min_Max[18],
		 subset[Selected_Subset_Type].SP_PHI_MIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 19, subset_limit_entry[18], input_subset_limit);

	sprintf(subset_limit_entry[19], "%s   %6.2f PI", XYZ_Min_Max[19],
		 subset[Selected_Subset_Type].SP_PHI_MAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 20, subset_limit_entry[19], input_subset_limit);

	sprintf(subset_limit_entry[20], "%s   %6.2f", XYZ_Min_Max[20],
		 subset[Selected_Subset_Type].SP_X_CENTER);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 21, subset_limit_entry[20], input_subset_limit);

	sprintf(subset_limit_entry[21], "%s   %6.2f", XYZ_Min_Max[21],
		 subset[Selected_Subset_Type].SP_Y_CENTER);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 22, subset_limit_entry[21], input_subset_limit);

	sprintf(subset_limit_entry[22], "%s   %6.2f", XYZ_Min_Max[22],
		 subset[Selected_Subset_Type].SP_Z_CENTER);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 23, subset_limit_entry[22], input_subset_limit);


	sprintf(subset_limit_entry[23], "%s   %6.2f", XYZ_Min_Max[23],
		 subset[Selected_Subset_Type].S_XMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 24, subset_limit_entry[23], input_subset_limit);

	sprintf(subset_limit_entry[24], "%s   %6.2f", XYZ_Min_Max[24],
		 subset[Selected_Subset_Type].S_XMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 25, subset_limit_entry[24], input_subset_limit);

	sprintf(subset_limit_entry[25], "%s   %6.2f", XYZ_Min_Max[25],
		 subset[Selected_Subset_Type].S_YMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 26, subset_limit_entry[25], input_subset_limit);

	sprintf(subset_limit_entry[26], "%s   %6.2f", XYZ_Min_Max[26],
		 subset[Selected_Subset_Type].S_YMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 27, subset_limit_entry[26], input_subset_limit);

	sprintf(subset_limit_entry[27], "%s   %6.2f", XYZ_Min_Max[27],
		 subset[Selected_Subset_Type].S_ZMIN);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 28, subset_limit_entry[27], input_subset_limit);

	sprintf(subset_limit_entry[28], "%s   %6.2f", XYZ_Min_Max[28],
		 subset[Selected_Subset_Type].S_ZMAX);
	Init_VN_Menu_Entry(&Subset_Shape_Size_Items, 29, subset_limit_entry[28], input_subset_limit);

/*
	 if(VN_Menu_Entry-1 == CUBIC)
		{
		i=7;
		while(i<30)
		 {
	PopupMakeEntryUnavailable(p_subset_limits,i);
	i++;
		 }
		PopupSelectMenu( p_subset_limits, 1, 1);
		}

		if(VN_Menu_Entry-1 == CYLINDRICAL)
		 {
		i = 1;
		while(i < 30)
			 {
	if((i < 7) || (i > 14))
		PopupMakeEntryUnavailable(p_subset_limits,i);
	i++;
			 }
		PopupSelectMenu( p_subset_limits, 1, 14);
		 }


		if(VN_Menu_Entry-1 == SPHERICAL)
		 {
			i = 1;
		while(i < 30)
			 {
	if((i < 15) || (i > 23))
		PopupMakeEntryUnavailable(p_subset_limits,i);
	i++;
			 }
		PopupSelectMenu( p_subset_limits, 1, 23);
		}


	 if(VN_Menu_Entry-1 == SLICE)
		 {
			i=1;
		while(i<24)
			 {
	PopupMakeEntryUnavailable(p_subset_limits,i);
	i++;
			 }
			PopupSelectMenu( p_subset_limits, 1, 29);
		}
*/

	Handle_VN_Menu(&Subset_Shape_Size_Items, 1);
	Close_VN_Menu(&Subset_Shape_Size_Items);
		}
	 else
		 {
			printf(" Row = %d\n",Selected_Subset_Type+1);
			printf(" Now is the time to enter limits for cylindrical cell\n\n  Hit any key to continue ...");
			subset[Selected_Subset_Type].TYPE=VN_Menu_Entry-1;
		 }
	}
	i=getch();
	return(VN_MENU_EXIT);
 }







int input_subset_limits(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int i;
	float a;
	char temp[50];
		VN_New_Screen();
		i=VN_Menu_Entry-1;
		printf("%s  ? ",XYZ_Min_Max[i]);

		 switch (i)
			{
			 case 0:
	{
	 a = get_float(subset[Selected_Subset_Type].XMIN);
	 subset[Selected_Subset_Type].XMIN = a;
	 break;
	}
		 case 1:
	{
	 a = get_float(subset[Selected_Subset_Type].XMAX);
	 subset[Selected_Subset_Type].XMAX = a;
	 break;
	}
		 case 2:
	{
	 a = get_float(subset[Selected_Subset_Type].YMIN);
	 subset[Selected_Subset_Type].YMIN = a;
	 break;
	}
			 case 3:
	{
	 a = get_float(subset[Selected_Subset_Type].YMAX);
	 subset[Selected_Subset_Type].YMAX = a;
	 break;
	}
		 case 4:
	{
	 a = get_float(subset[Selected_Subset_Type].ZMIN);
	 subset[Selected_Subset_Type].ZMIN = a;
	 break;
	}
			 case 5:
	{
	 a = get_float(subset[Selected_Subset_Type].ZMAX);
	 subset[Selected_Subset_Type].ZMAX = a;
	 break;
	}



			 case 6:
	{
	 a = get_float(subset[Selected_Subset_Type].C_RMIN);
	 subset[Selected_Subset_Type].C_RMIN = a;
	 break;
	}
		 case 7:
	{
	 a = get_float(subset[Selected_Subset_Type].C_RMAX);
	 subset[Selected_Subset_Type].C_RMAX = a;
	 break;
	}
			 case 8:
	{
	 a = get_float(subset[Selected_Subset_Type].C_THETA_MIN);
	 subset[Selected_Subset_Type].C_THETA_MIN=a;
	 break;
	}
			 case 9:
	{
	 a = get_float(subset[Selected_Subset_Type].C_THETA_MAX);
	 subset[Selected_Subset_Type].C_THETA_MAX=a;
	 break;
	}
			 case 10:
	{
	 a = get_float(subset[Selected_Subset_Type].C_ZMIN);
	 subset[Selected_Subset_Type].C_ZMIN=a;
	 break;
	}
		 case 11:
	{
	 a = get_float(subset[Selected_Subset_Type].C_ZMAX);
	 subset[Selected_Subset_Type].C_ZMAX=a;
	 break;
	}
		 case 12:
	{
	 a = get_float(subset[Selected_Subset_Type].C_X_CENTER);
	 subset[Selected_Subset_Type].C_X_CENTER=a;
	 break;
	}
			 case 13:
	{
	 a = get_float(subset[Selected_Subset_Type].C_Y_CENTER);
	 subset[Selected_Subset_Type].C_Y_CENTER=a;
	 break;
	}



			 case 14:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_RMIN);
	 subset[Selected_Subset_Type].SP_RMIN = a;
	 break;
	}
			 case 15:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_RMAX);
	 subset[Selected_Subset_Type].SP_RMAX = a;
	 break;
	}
		 case 16:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_THETA_MIN);
	 subset[Selected_Subset_Type].SP_THETA_MIN=a;
	 break;
	}
		 case 17:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_THETA_MAX);
	 subset[Selected_Subset_Type].SP_THETA_MAX=a;
	 break;
	}
			 case 18:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_PHI_MIN);
	 subset[Selected_Subset_Type].SP_PHI_MIN=a;
	 break;
	}
			 case 19:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_PHI_MAX);
	 subset[Selected_Subset_Type].SP_PHI_MAX=a;
	 break;
	}
		 case 20:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_X_CENTER);
	 subset[Selected_Subset_Type].SP_X_CENTER=a;
	 break;
	}
		 case 21:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_Y_CENTER);
	 subset[Selected_Subset_Type].SP_Y_CENTER=a;
	 break;
	}
			 case 22:
	{
	 a = get_float(subset[Selected_Subset_Type].SP_Z_CENTER);
	 subset[Selected_Subset_Type].SP_Z_CENTER=a;
	 break;
	}



			 case 23:
	{
	 a = get_float(subset[Selected_Subset_Type].S_XMIN);
	 subset[Selected_Subset_Type].S_XMIN = a;
	 break;
	}
			 case 24:
	{
	 a = get_float(subset[Selected_Subset_Type].S_XMAX);
	 subset[Selected_Subset_Type].S_XMAX = a;
	 break;
	}
			 case 25:
	{
	 a = get_float(subset[Selected_Subset_Type].S_YMIN);
	 subset[Selected_Subset_Type].S_YMIN=a;
	 break;
	}
		 case 26:
	{
	 a = get_float(subset[Selected_Subset_Type].S_YMAX);
	 subset[Selected_Subset_Type].S_YMAX=a;
	 break;
	}
			 case 27:
	{
	 a = get_float(subset[Selected_Subset_Type].S_ZMIN);
	 subset[Selected_Subset_Type].S_ZMIN=a;
	 break;
	}
		 case 28:
	{
	 a = get_float(subset[Selected_Subset_Type].S_ZMAX);
	 subset[Selected_Subset_Type].S_ZMAX=a;
	 break;
	}

		}

		sprintf(temp, "%s   %6.2f",XYZ_Min_Max[i],a);
		Change_VN_Menu_Entry(VN_Menu_Name, VN_Menu_Entry, temp);
		return(VN_MENU_CONTINUE);
 }



int menu_alloy_random(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		Setting_IAP_Element = DESH_NO;
		p_Random_Alloy = PopupCreateMenu(Random_Alloy_items,
					menu_colors,
					5,40,2,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
		PopupSelectMenu( p_Random_Alloy, 1, 1);
		PopupMenuFree(p_Random_Alloy);
		return(PULLDOWN_EXIT);
  }

int Read_Perc_or_Number( POPUP_MENU_PTR p, unsigned which)
	{

	 Number_Percentage_menu_array=PopupAllocate(DESH_TWO);
			sprintf(Number_Percentage_Entry[0], "%s %6.0f",
					Number_Percentage[0], Random_Alloy_Number);
			PopupCreateEntry(Number_Percentage_menu_array, 1,
				Number_Percentage_Entry[0],
				1, 0, 0, input_alloy_percentage_or_number);

			sprintf(Number_Percentage_Entry[1], "%s %6.2f",
					Number_Percentage[1], Random_Alloy_Percentage);
			PopupCreateEntry(Number_Percentage_menu_array, 2,
				Number_Percentage_Entry[1],
				2, 0, 0, input_alloy_percentage_or_number);

			PopupEntryEnd(Number_Percentage_menu_array, DESH_TWO);

			p_Number_Percentage = PopupCreateMenu(Number_Percentage_menu_array,
				  menu_colors,
					9,3,DESH_TWO,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);

	 PopupSelectMenu( p_Number_Percentage, 1, Alloy_Composition+1);

	 PopupDeallocate( Number_Percentage_menu_array);
	 return(POPUP_CONTINUE);
	}

int input_alloy_percentage_or_number( POPUP_MENU_PTR p, unsigned which)
	{
  int i;
  float a;
  char temp[50];

	  WindowClear(pw);
	  WindowDisplay(pw,1,NOEFFECT);

	  Alloy_Composition = (int)which-1;
		i=which-1;
	  switch (i)
		{
			case DESH_ZERO:
				{
					WindowPrintf(pw,"%s = %6.0f ? ",
							Number_Percentage[i], Random_Alloy_Number);
					a = get_float(Random_Alloy_Number);
					if(a< 0)
						a=0.;
					if(a > Total_Atoms)
						a=Total_Atoms;
					Random_Alloy_Number=a;
					sprintf(temp, "%s %6.0f",Number_Percentage[i],a);
					break;
				}
			case DESH_ONE:
				{
					WindowPrintf(pw,"%s = %6.3f ? ",
							Number_Percentage[i], Random_Alloy_Percentage);
					a= get_float(Random_Alloy_Percentage);
					if(a < 0)
						a=0.;
					if(a > 100.)
						a=100.;

					Random_Alloy_Percentage=a;
					sprintf(temp, "%s %6.2f",Number_Percentage[i],Random_Alloy_Percentage);
					break;
				}
		}

	  PopupChangeEntryString(p_Number_Percentage, which, temp);
	  WindowHide(pw,NOEFFECT);
	  return(POPUP_CONTINUE);
	}


int Get_Random_Alloy_Element( POPUP_MENU_PTR p, unsigned which)
	{
		Setting_IAP_Element = DESH_NO;
		p_IAP_Alloy_Element_items = PopupCreateMenu(IAP_Alloy_element_items,
				  menu_colors,
				  9,35,10,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);
		PopupSelectMenu( p_IAP_Alloy_Element_items, 1, Selected_IAP_Element+1);
		PopupMenuFree(p_IAP_Alloy_Element_items);
		return(POPUP_EXIT);
	}


int menu_alloy_systematic(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
{
	 int i, i1, i2, j, M_Entries;
	 char	temp[50];

	 if((Current_Cell_Type < SC) || (Current_Cell_Type > USER_UC))
		{
			WindowClear(pw);
			WindowDisplay(pw,1,EXPLODE);
			WindowPrintf(pw, "\n The type of unit cell (FCC, DC, etc) is not defined");
			WindowPrintf(pw, "\n\n Hit any key to continue ...");
			i=getch();
			WindowHide(pw,NOEFFECT);
			return(POPUP_EXIT);
		}

	 M_Entries = Unit_Cell_Atoms[Current_Cell_Type].No_of_U_Cell_Atoms+3;

	 alloy_systematic_menu_array=PopupAllocate(M_Entries);
	 for(i=0; i< 3; i++)
		{
			sprintf(Alloy_Systematic_Entry[i], "%s %6.3f",
					Alloy_Systematic[i], Lattice_D[i]);
			PopupCreateEntry(alloy_systematic_menu_array, i+1,
				Alloy_Systematic_Entry[i],
				i+1, 0, 0, input_lattice_constant);
		}

	 for(i=0; i<Unit_Cell_Atoms[Current_Cell_Type].No_of_U_Cell_Atoms; i++)
		{
			strcpy(Alloy_Systematic_Entry[i+3], "At ( ");
			for(j=0; j<3; j++)
				{
					decimal_to_fract( &i1, &i2,
						Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][j]);
					if(i1 == 0)
						sprintf(temp," 0 ");
					else
						sprintf(temp,"%1d/%1d",i1,i2);
					if(j < 2)
						strcat(temp,", ");
					else
						strcat(temp," ) : ");
					strcat(Alloy_Systematic_Entry[i+3], temp);
				}
			strcat(Alloy_Systematic_Entry[i+3],
				Chem_Sym[Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][3]]);

			PopupCreateEntry(alloy_systematic_menu_array, i+4,
			 Alloy_Systematic_Entry[i+3],
			 i+4, 0, 0, input_atom_type);
		}

	 PopupEntryEnd(alloy_systematic_menu_array, M_Entries);
	 p_alloy_systematic = PopupCreateMenu(alloy_systematic_menu_array,
				  menu_colors,
				  9,3,13,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);
	 PopupSelectMenu( p_alloy_systematic, 1, 1);
	 PopupDeallocate( alloy_systematic_menu_array);

	return(POPUP_EXIT);
}

void	decimal_to_fract(int *i1, int* i2, float a)
	{
		int i,j;
		float	b,c;
		if(a == 0)
			{
				*i1 = 0; *i2=1;
			}
		else
			{
				b=1.-a;
				*i1 = 1;
				for(i=1; i<10; i++)
					{
					 for(j=i+1; j<= 10; j++)
					  {
						c = a - (float)i/(float)j;
						if(c < 0)
							c = -c;
						if(c < b)
							{
								b = c;
								*i1 = i;
								*i2 = j;
							}
					  }
					}
			}
	}



int input_lattice_constant( POPUP_MENU_PTR p, unsigned which)
 {
  int i;
  float a;
  char temp[50];

	  WindowClear(pw);
	  WindowDisplay(pw,1,NOEFFECT);

		i=which-1;
	  WindowPrintf(pw,"%s  ? ",Alloy_Systematic[i]);
	  a = get_float(Lattice_D[i]);
	  Lattice_D[i]=a;

	  sprintf(temp, "%s %6.3f",Alloy_Systematic[i],a);
	  PopupChangeEntryString(p_alloy_systematic, which, temp);
	  WindowHide(pw,NOEFFECT);
	  return(POPUP_CONTINUE);
 }

int input_atom_type( POPUP_MENU_PTR p, unsigned which)
	{
		int	i,j,i1,i2;
		char temp[50],temp1[50];

      Setting_IAP_Element = DESH_NO;
		p_IAP_Alloy_Element_items = PopupCreateMenu(IAP_Alloy_element_items,
				  menu_colors,
				  9,35,10,
					POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);
		PopupSelectMenu( p_IAP_Alloy_Element_items, 1, Selected_IAP_Element+1);
		PopupMenuFree(p_IAP_Alloy_Element_items);

		i=which-4;
		Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][3] =
				(int)Selected_Alloy_Atom_Type;

			strcpy(temp1, "At ( ");
			for(j=0; j<3; j++)
				{
					decimal_to_fract( &i1, &i2,
						Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][j]);
					if(i1 == 0)
						sprintf(temp," 0 ");
					else
						sprintf(temp,"%1d/%1d",i1,i2);
					if(j < 2)
						strcat(temp,", ");
					else
						strcat(temp," ) : ");
					strcat(temp1, temp);
				}
		strcat(temp1, Chem_Sym[Selected_Alloy_Atom_Type]);
		PopupChangeEntryString(p_alloy_systematic, which, temp1);
		return(POPUP_CONTINUE);
	}

int	Set_Alloy_Atom_Type( POPUP_MENU_PTR p, unsigned which)
	{
		Selected_Alloy_Atom_Type = which-1;
		return(POPUP_EXIT);
	}

int menu_alloy_make(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		int i,j,k;
		int	atoms_to_change, atoms_changed, Atoms_Within_Subset;
		float	a, random_threshold;

		randomize();
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		if(Total_Atoms <= 0)
			{
				WindowPrintf(pw, "\n No cell created");
				WindowPrintf(pw, "\n\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
				return(PULLDOWN_CONTINUE);
			}
		Atoms_Within_Subset=0;
		i=0;
		atom_ptr=atom_ptr_temp;
		while(i<Total_Atoms)
			{
				if(check_within_subset(atom_ptr->XC,
														atom_ptr->YC,
														atom_ptr->ZC, ALLOY) == DESH_IN_SIDE)
					{
						Atoms_Within_Subset++;
					}
				i++;
				atom_ptr++;
			}
		if(Atoms_Within_Subset <= 0)
			{
				WindowPrintf(pw, "\n No atoms within the subset to make alloy");
				WindowPrintf(pw, "\n\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
				return(PULLDOWN_CONTINUE);
			}

		File_Modification = DESH_YES;
		switch (Alloy_Composition)
			{
				case DESH_ZERO:
					{
						atoms_to_change = Random_Alloy_Number;
						random_threshold = (float)atoms_to_change /
												 (float)Atoms_Within_Subset;
						break;
					}
				case DESH_ONE:
					{
						atoms_to_change = 1 +
						 (int) ((float) Total_Atoms * Random_Alloy_Percentage / 100.);
						random_threshold = Random_Alloy_Percentage/100.;
						break;
					}
			}

		i=0;
		atoms_changed=0;
		atom_ptr=atom_ptr_temp;
		while(i<Total_Atoms)
			{
				if(check_within_subset(atom_ptr->XC,
														atom_ptr->YC,
														atom_ptr->ZC, ALLOY) == DESH_IN_SIDE)
					{
						a = (float)(random(10000))/10000.;
						if(a < random_threshold)
							{
								atom_ptr->TYPE = Selected_Alloy_Atom_Type;
								atoms_changed++;
							}
					}
				atom_ptr++;
				i++;
			}

		WindowClear(pw);
		WindowPrintf(pw, "Atoms of alloy type = %d or %6.2f", atoms_changed,
											(100.*(float)atoms_changed/(float)Atoms_Within_Subset));
		WindowPrintf(pw, "\n\n Hit any key to continue ...");
		i=getch();
		WindowClear(pw);
		WindowHide(pw, NOEFFECT);
		return(PULLDOWN_CONTINUE);
	}






int menu_dislocation(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	 {
    int i;
    char temp[12];

    Selected_Dislocation = vs-1;

    dislocation_menu_array=PopupAllocate(DISLOCATION_PARAM);

    i=0;
    while(i<DISLOCATION_PARAM)
     {
       strcpy(Dislocation_Menu_Entry[i], Dislocation_Entry[i]);
       i++;
     }

	 strcat(Dislocation_Menu_Entry[0], D_Type[Dislocation[vs-1].D_TYPE]);
    sprintf(temp,"%7.2f", Dislocation[vs-1].D_X);
	 strcat(Dislocation_Menu_Entry[1],temp);
    sprintf(temp,"%7.2f", Dislocation[vs-1].D_Y);
    strcat(Dislocation_Menu_Entry[2],temp);
		sprintf(temp,"%7.2f", Dislocation[vs-1].D_VECTOR);
    strcat(Dislocation_Menu_Entry[3],temp);
    strcat(Dislocation_Menu_Entry[4], D_Orientation[Dislocation[vs-1].D_ORIENTATION]);
    strcat(Dislocation_Menu_Entry[5], D_Line[Dislocation[vs-1].D_LINE]);

    PopupCreateEntry(dislocation_menu_array, 1,
			 Dislocation_Menu_Entry[0],
			 1, 0, 0, input_dislocation_TYPE);
    PopupCreateEntry(dislocation_menu_array, 2,
			 Dislocation_Menu_Entry[1],
			 2, 0, 0, input_dislocation_XY);
    PopupCreateEntry(dislocation_menu_array, 3,
			 Dislocation_Menu_Entry[2],
			 3, 0, 0, input_dislocation_XY);
    PopupCreateEntry(dislocation_menu_array, 4,
			 Dislocation_Menu_Entry[3],
			 4, 0, 0, input_dislocation_XY);
	 PopupCreateEntry(dislocation_menu_array, 5,
			 Dislocation_Menu_Entry[4],
			 5, 0, 0, input_dislocation_ORIENTATION);
		PopupCreateEntry(dislocation_menu_array, 6,
			 Dislocation_Menu_Entry[5],
			 6, 0, 0, input_dislocation_LINE);


    PopupEntryEnd(dislocation_menu_array, DISLOCATION_PARAM);
    p_dislocation = PopupCreateMenu(dislocation_menu_array,
			     menu_colors,
				  5,10,6,
			     POPUPWRAP | POPUPSTATIC,
			     WNULLFN, VWNULLFN);

    PopupSelectMenu( p_dislocation, 1, 1);

    PopupDeallocate( dislocation_menu_array);

   return(PULLDOWN_EXIT);
 }


int input_dislocation( POPUP_MENU_PTR p, unsigned which)
 {
  int i;
     WindowClear(pw);
     WindowDisplay(pw,1,NOEFFECT);
     i=getch();
     WindowHide(pw,NOEFFECT);
     return(POPUP_CONTINUE);
  }

int input_dislocation_XY( POPUP_MENU_PTR p, unsigned which)
 {
  int i;
  float a;
  char temp[35];
     WindowClear(pw);
     WindowDisplay(pw,1,NOEFFECT);
	  if(which == 2)
      {
       WindowPrintf(pw," X = ");
       a = get_float(Dislocation[Selected_Dislocation].D_X);
       Dislocation[Selected_Dislocation].D_X=a;
       sprintf(temp, "%s%7.2f",Dislocation_Entry[1],a);
      }
     if(which == 3)
      {
       WindowPrintf(pw," Y = ");
       a = get_float(Dislocation[Selected_Dislocation].D_Y);
		 Dislocation[Selected_Dislocation].D_Y=a;
       sprintf(temp, "%s%7.2f",Dislocation_Entry[2],a);
      }
     if(which == 4)
      {
       WindowPrintf(pw," Burger's vector = ");
       a = get_float(Dislocation[Selected_Dislocation].D_VECTOR);
       Dislocation[Selected_Dislocation].D_VECTOR=a;
       sprintf(temp, "%s%7.2f",Dislocation_Entry[3],a);
		}

     PopupChangeEntryString(p_dislocation, which, temp);
	  WindowHide(pw,NOEFFECT);
     return(POPUP_CONTINUE);
  }



int input_dislocation_TYPE( POPUP_MENU_PTR p, unsigned which)
 {
  p_dislocation_type = PopupCreateMenu(dislocation_type_items,
				  menu_colors,
					10,35,3,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
  PopupSelectMenu( p_dislocation_type, 1, 1);
  PopupMenuFree( p_dislocation_type);
  return(POPUP_CONTINUE);
 }

int get_dislocation_type( POPUP_MENU_PTR p, unsigned which)
 {
  char temp[35];
  int	i;

/*
		 if((which-1 != NINTY_DEGREE) && (which-1 != NULL_TYPE))
			{
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n %s type dislocation is not implimented", D_Type[which-1]);
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
				return(POPUP_CONTINUE);
			}
*/
		 Dislocation[Selected_Dislocation].D_TYPE=which-1;
		 sprintf(temp, "%s%s",Dislocation_Entry[0],D_Type[which-1]);
		 PopupChangeEntryString(p_dislocation, 1, temp);
		 return(POPUP_EXIT);
 }

int input_dislocation_ORIENTATION( POPUP_MENU_PTR p, unsigned which)
 {
  p_dislocation_orientation = PopupCreateMenu(dislocation_orientation_items,
				  menu_colors,
				  10,35,2,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);
  PopupSelectMenu( p_dislocation_orientation, 1, 1);
  PopupMenuFree( p_dislocation_orientation);
  return(POPUP_CONTINUE);
 }

int get_dislocation_orientation( POPUP_MENU_PTR p, unsigned which)
 {
  char temp[35];

		 Dislocation[Selected_Dislocation].D_ORIENTATION=which-1;
		 sprintf(temp, "%s%s",Dislocation_Entry[4],D_Orientation[which-1]);
		 PopupChangeEntryString(p_dislocation, 5, temp);
		 return(POPUP_EXIT);
 }


int input_dislocation_LINE( POPUP_MENU_PTR p, unsigned which)
 {
  p_dislocation_line = PopupCreateMenu(dislocation_line_items,
				  menu_colors,
				  10,35,3,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);
  PopupSelectMenu( p_dislocation_line, 1, 1);
  PopupMenuFree( p_dislocation_line);
  return(POPUP_CONTINUE);
 }

int get_dislocation_line( POPUP_MENU_PTR p, unsigned which)
 {
	char temp[35];
		 Dislocation[Selected_Dislocation].D_LINE=which-1;
		 sprintf(temp, "%s%s",Dislocation_Entry[5],D_Line[which-1]);
		 PopupChangeEntryString(p_dislocation, 6, temp);
		 return(POPUP_EXIT);
 }


int compute_dislocation(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {
  int 		i,j,k;
  float		a, b, c, d, e;
  float		x, y, ux, uy, uz, dx, dy;
  float		nu;
  float         tan_yx;

	if(Total_Atoms <= 0)
		{
			WindowClear(pw);
			WindowDisplay(pw, 1, EXPLODE);
			WindowPrintf(pw, "\n No computational cell");
			WindowPrintf(pw, "\n Hit any key to continue ...");
			i=getch();
			WindowClear(pw);
			WindowHide(pw, NOEFFECT);
			return(PULLDOWN_CONTINUE);
		}
  File_Modification = DESH_YES;
  i=0;
  atom_ptr=atom_ptr_temp;
	while(i<Total_Atoms)
	{
	 ux = 0.;	uy = 0.;	uz = 0.;
	 j=0;
	 while(j<DISLOCATION_ENTRIES)
		{
			dx = 0.;
			dy = 0.;
			if(Dislocation[j].D_TYPE == NULL_TYPE)
			 {
				j++;
				continue;
			 }

			if(Dislocation[j].D_TYPE == SCREW)
				{
					switch (Dislocation[j].D_LINE)
						{
							case LINE_Z:
							 {
								x = atom_ptr->XC - Dislocation[j].D_X;
								y = atom_ptr->YC - Dislocation[j].D_Y;
								tan_yx = get_angle(x, y);
								d = Dislocation[j].D_VECTOR / (2.*PI);
								uz = uz+d*tan_yx;
								break;
							 }
							case LINE_Y:
							 {
								x = atom_ptr->XC - Dislocation[j].D_X;
								y = atom_ptr->ZC - Dislocation[j].D_Y;
								tan_yx = get_angle(x, y);
								d = Dislocation[j].D_VECTOR / (2.*PI);
								uy = uz+d*tan_yx;
								break;
							 }
							case LINE_X:
							 {
								x = atom_ptr->ZC - Dislocation[j].D_X;
								y = atom_ptr->YC - Dislocation[j].D_Y;
								tan_yx = get_angle(x, y);
								d = Dislocation[j].D_VECTOR / (2.*PI);
								ux = uz+d*tan_yx;
								break;
							 }
						}
					j++;
					continue;
				}


			if(Dislocation[j].D_TYPE == EDGE)
			 {
				switch (Dislocation[j].D_LINE)
					{
						case LINE_Z:
						 {
							x = atom_ptr->XC - Dislocation[j].D_X;
							y = atom_ptr->YC - Dislocation[j].D_Y;
							break;
						 }
						case LINE_Y:
						 {
							x = atom_ptr->XC - Dislocation[j].D_X;
							y = atom_ptr->ZC - Dislocation[j].D_Y;
							break;
						 }
						case LINE_X:
						 {
							x = atom_ptr->ZC - Dislocation[j].D_X;
							y = atom_ptr->YC - Dislocation[j].D_Y;
							break;
						 }
					}

				if(Dislocation[j].D_ORIENTATION == DISLOCATION_NEGATIVE)
				 {
					x = -x;
					y = -y;
				 }

				if((x == 0.) && (y == 0.))
				 {
					j++;
					continue;
				 }

				tan_yx = get_angle(x, y);

				a = 1. - Element[atom_ptr->TYPE].NU;
				b = x*x + y*y;
				c = x*x - y*y;
				d = Dislocation[j].D_VECTOR / (2.*PI);
				e = (float)log((double)b);

				dx = d * (tan_yx + (x*y)/(2.*a*b));
				dy = -d * (((2.*a - 1.) *  e / (4. * a)) + (c / (4.*a*b)));

				if(Dislocation[j].D_ORIENTATION == DISLOCATION_NEGATIVE)
				 {
					dx = -dx;
					dy = -dy;
				 }

				switch (Dislocation[j].D_LINE)
					{
					 case LINE_Z:
						{
						 ux = ux + dx;
						 uy = uy + dy;
						 break;
						}

					 case LINE_Y:
						{
						 ux = ux + dx;
						 uz = uz + dy;
						 break;
						}

					 case LINE_X:
						{
						 uz = uz + dx;
						 uy = uy + dy;
						 break;
						}
					}
				j++;
				continue;
			 }

		j++;		/* Dislocation type is unknown */
	}

		atom_ptr->XC = atom_ptr->XC + ux;
		atom_ptr->YC = atom_ptr->YC + uy;
		atom_ptr->ZC = atom_ptr->ZC + uz;
    atom_ptr++;
    i++;
   }
  return(PULLDOWN_EXIT);
 }


int menu_tensile(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
   {
    int i;

	 tensile_strain_menu_array=PopupAllocate(STRAIN_ENTRIES);

      i=0;
		while(i<STRAIN_ENTRIES)
       {
	sprintf(Tensile_Strain_Entry[i], "%s%6.3f", Tensile_Strain[i],
		 Tensile_Strain_Values[i]);
	PopupCreateEntry(tensile_strain_menu_array, i+1,
			 Tensile_Strain_Entry[i],
			 i+1, 0, 0, input_strain);
	i++;
       }

	 PopupEntryEnd(tensile_strain_menu_array, STRAIN_ENTRIES);
	 p_tensile_strain = PopupCreateMenu(tensile_strain_menu_array,
			     menu_colors,
			     9,3,3,
			     POPUPWRAP | POPUPSTATIC,
			     WNULLFN, VWNULLFN);

	 PopupSelectMenu( p_tensile_strain, 1, 1);

	 PopupDeallocate( tensile_strain_menu_array);

   return(PULLDOWN_EXIT);
 }



int input_strain( POPUP_MENU_PTR p, unsigned which)
 {
  int i;
  float a;
  char temp[50];
	  WindowClear(pw);
     WindowDisplay(pw,1,NOEFFECT);

     i=which-1;
	  WindowPrintf(pw,"%s  ? ",Tensile_Strain[i]);
		a = get_float(Tensile_Strain_Values[i]);
	  Tensile_Strain_Values[i]=a;

	  sprintf(temp, "%s%6.3f",Tensile_Strain[i],a);
	  PopupChangeEntryString(p_tensile_strain, which, temp);
     WindowHide(pw,NOEFFECT);
     return(POPUP_CONTINUE);
 }

int menu_shear(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		int i;
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw, "\n The shear strain menu is not implemented in this version");
		WindowPrintf(pw, "\n Hit any key to continue ...");
		i=getch();
		WindowClear(pw);
		WindowHide(pw, NOEFFECT);
		return(PULLDOWN_CONTINUE);
	}


int menu_strain (PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {
	int i;

	if(Compute_Tensile_Strain() == DESH_NO)
		return(PULLDOWN_EXIT);
	WindowClear(pw);
	WindowDisplay(pw, 1, EXPLODE);
	WindowPrintf(pw, "\n Tensile strain applied to the cell\n");
	WindowPrintf(pw, "\n Hit any key to continue ...");
	i=getch();
	WindowClear(pw);
	WindowHide(pw, NOEFFECT);
	return(PULLDOWN_EXIT);
 }



int menu_translation(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
	  int	i;

	  translation_menu_array=PopupAllocate(TRANSLATION_PARAM);
	  i=0;
	  while(i<TRANSLATION_PARAM)
		{
		 sprintf(Translation_Menu_Entry[i], "%s : %7.2f",
					Translation_Entry[i], Rigid_Disp[i]);
		 PopupCreateEntry(translation_menu_array, i+1,
			 Translation_Menu_Entry[i],
			 i+1, 0, 0, input_rigid_displacement);
		 i++;
		}
	  PopupEntryEnd(translation_menu_array, TRANSLATION_PARAM);
	  p_translation = PopupCreateMenu(translation_menu_array,
				  menu_colors,
				  5,10,TRANSLATION_PARAM,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);

	 PopupSelectMenu( p_translation, 1, 1);
	 PopupDeallocate( translation_menu_array);
	 PopupMenuFree( p_translation);
	 return(PULLDOWN_EXIT);
	}

int input_rigid_displacement( POPUP_MENU_PTR p, unsigned which)
	{
		float a;
		char temp[40];
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw,"%s = %7.2f ? ",Translation_Entry[which-1],Rigid_Disp[which-1]);
		a = get_float(Rigid_Disp[which-1]);
		Rigid_Disp[which-1]=a;
		sprintf(temp, "%s : %7.2f",
					Translation_Entry[which-1], Rigid_Disp[which-1]);
		PopupChangeEntryString(p_translation, which, temp);
		WindowHide(pw, NOEFFECT);
		return(POPUP_CONTINUE);
	}

int menu_rotation(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
	  int	i;

	  rotation_menu_array=PopupAllocate(ROTATION_PARAM);
	  i=0;
	  while(i<ROTATION_PARAM)
		{
		 sprintf(Rotation_Menu_Entry[i], "%s : %7.2f",
					Rotation_Entry[i], Rotate_Deg[i]);
		 PopupCreateEntry(rotation_menu_array, i+1,
			 Rotation_Menu_Entry[i],
			 i+1, 0, 0, input_rotation_degrees);
		 i++;
		}
	  PopupEntryEnd(rotation_menu_array, ROTATION_PARAM);
	  p_rotation = PopupCreateMenu(rotation_menu_array,
				  menu_colors,
				  5,10,ROTATION_PARAM,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);

	 PopupSelectMenu( p_rotation, 1, 1);
	 PopupDeallocate( rotation_menu_array);
	 PopupMenuFree( p_rotation);
	 return(PULLDOWN_EXIT);
	}


int input_rotation_degrees( POPUP_MENU_PTR p, unsigned which)
	{
		float a;
		char temp[30];
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw,"%s : %7.2f ? ",Rotation_Entry[which-1],Rotate_Deg[which-1]);
		a = get_float(Rotate_Deg[which-1]);
		Rotate_Deg[which-1]=a;
		sprintf(temp, "%s : %7.2f",
					Rotation_Entry[which-1], Rotate_Deg[which-1]);
		PopupChangeEntryString(p_rotation, which, temp);
		WindowHide(pw, NOEFFECT);
		return(POPUP_CONTINUE);
	}

int menu_rigid_displacement(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {

	int	i;
		if(Compute_Translational_Displacement() == DESH_YES)
			{
				WindowClear(pw);
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n Translational Displacement Calculated\n");
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
			}
		return(PULLDOWN_EXIT);
 }


int menu_rotational_displacement(PULLDOWN_MENU_PTR p, BAR_MENU_PTR c,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {
		int i;

		if(Compute_Rotational_Displacement() == DESH_YES)
			{
				WindowClear(pw);
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n Rotational displacements calculated\n");
				WindowPrintf(pw, "\n Hit any key to continue ....");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
			}
		return(PULLDOWN_EXIT);

 }


int menu_make_cell(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {
  int	XPASS, YPASS, ZPASS;
	int	IX, IY, IZ;
	int i, j;
	float a,b,c,d,e,f;

	WindowClear(pw);
	WindowDisplay(pw,1,NOEFFECT);

	if((Current_Cell_Type < SC) || (Current_Cell_Type > USER_UC))
	{
	 WindowPrintf(pw, "Unable to create cell. Cell type not defined\n\n");
	 WindowPrintf(pw, "Hit any key to continue ...");
	 i=getch();
	 WindowHide(pw,NOEFFECT);
	 return(PULLDOWN_CONTINUE);
	}

	j=0;
	for(i=0; i<Unit_Cell_Atoms[Current_Cell_Type].No_of_U_Cell_Atoms; i++)
	{
		if(Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][3] == VACANCY)
			j++;
	}
	if(j == Unit_Cell_Atoms[Current_Cell_Type].No_of_U_Cell_Atoms)
	{
		WindowPrintf(pw,"Unable to create cell. No atoms defined\n\n");
		WindowPrintf(pw, "Hit any key to continue ...");
		i=getch();
		WindowHide(pw,NOEFFECT);
		return(PULLDOWN_CONTINUE);
	}

		if(Total_Atoms > 0)
			{
				WindowPrintf(pw, "\n  Append to current computation cell (Y/N) ? ");
				i=0;
				while((i != 'Y') && (i != 'y') && (i != 'N') && (i != 'n'))
					{
						i=getch();
					}
				if((i == 'N') || (i == 'n'))
					{
						atom_ptr=atom_ptr_temp;
						Total_Atoms=0;
					}
				else
					{
						atom_ptr=atom_ptr_temp;
						for(j=0; j<Total_Atoms; j++, atom_ptr++);
					}
			}
		else
					{
						atom_ptr=atom_ptr_temp;
						Total_Atoms=0;
					}


	File_Modification = DESH_YES;

//	Total_Atoms = 0;
//	atom_ptr=atom_ptr_temp;
	compute_cell_size_param();


	j = 2 * Cell_Size_Param + 1;

	IX=-Cell_Size_Param;
	while(IX < Cell_Size_Param)
	{
	 WindowPrintf(pw, "\b\b\b%3d", j);
	 j--;
	 IY = -Cell_Size_Param;
	 while(IY < Cell_Size_Param)
		{
		IZ = -Cell_Size_Param;
		while(IZ < Cell_Size_Param)
		 {
			i=0;
			while(i<Unit_Cell_Atoms[Current_Cell_Type].No_of_U_Cell_Atoms)
			 {
		a=(float)IX*Lattice_D[0];
		b=(float)IY*Lattice_D[1];
		c=(float)IZ*Lattice_D[2];
		a=a+Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][0] * Lattice_D[0];
		b=b+Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][1] * Lattice_D[1];
		c=c+Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][2] * Lattice_D[2];


/* Should do transformation for Miller indices */


		d=f_make[0][0]*a+f_make[0][1]*b+f_make[0][2]*c;
		e=f_make[1][0]*a+f_make[1][1]*b+f_make[1][2]*c;
		f=f_make[2][0]*a+f_make[2][1]*b+f_make[2][2]*c;

		a=d;	b=e;	c=f;

/* Transformation complete */

		if(check_within_subset(a, b, c, CELL_SIZE) == DESH_IN_SIDE)
			 {
			  atom_ptr->XC = a;
			  atom_ptr->YC = b;
			  atom_ptr->ZC = c;
			  atom_ptr->TYPE = (int)Unit_Cell_Atoms[Current_Cell_Type].U_Cell[i][3];
			  atom_ptr++;
			  Total_Atoms++;
			  if(Total_Atoms >= MAX_ATOMS)
				{
				 WindowPrintf(pw, "Reached maximum limit. Unable to continue\n");
				 WindowPrintf(pw, "Hit any key to continue ...");
				 i=getch();
				 WindowHide(pw,NOEFFECT);
				 return(PULLDOWN_CONTINUE);
				}
			 }
		i++;
			 }
			IZ++;
		 }
		IY++;
	  }
	 IX++;
	}

	 i=0;
	 while(i<3)
	  {
		for(j=0; j<3; j++)
		 {
	current_axes[i][j]=new_axes[i][j];
	current_basis_vector[i][j]=new_basis_vector[i][j];
		 }
		i++;
	  }

	 atom_ptr=atom_ptr_temp;
	 WindowPrintf(pw,"\nAtoms in the cell : %d     ",Total_Atoms);
	 File_Modification = DESH_YES;

	 WindowPrintf(pw,"Sorting the atoms .....");
	 planes_and_periodicity();
	 WindowHide(pw,NOEFFECT);
	 return(PULLDOWN_EXIT);

 }

void compute_cell_size_param(void)
	{
		auto float a,b;
		auto int i;

		i = subset[CELL_SIZE].TYPE;

	switch(i)
		{
			case CUBIC:
				{
					a = subset[CELL_SIZE].XMAX;
						if(a < 0)	a = -a;
					b = subset[CELL_SIZE].XMIN;	if(b < 0)	b = -b;
						if(a < b)	a = b;
					b = subset[CELL_SIZE].YMIN;	if(b < 0)	b = -b;
						if(a < b)	a = b;
					b = subset[CELL_SIZE].YMAX;	if(b < 0)	b = -b;
						if(a < b)	a = b;
					b = subset[CELL_SIZE].ZMIN;	if(b < 0)	b = -b;
						if(a < b)	a = b;
					b = subset[CELL_SIZE].ZMIN;	if(b < 0)	b = -b;
						if(a < b)	a = b;
					break;
				}
			case CYLINDRICAL:
				{
					a = subset[CELL_SIZE].C_ZMAX;
					if(a < 0)	a = -a;
					b = subset[CELL_SIZE].C_ZMIN;		if(b < 0)	b = -b;
						if(a < b)	a = b;
					b = subset[CELL_SIZE].C_RMAX + subset[CELL_SIZE].C_X_CENTER;
						if(b < 0)	b=-b;
						if(a < b)	a = b;
					b = -subset[CELL_SIZE].C_RMAX + subset[CELL_SIZE].C_X_CENTER;
						if(b < 0)	b=-b;
						if(a < b)	a = b;
					b = subset[CELL_SIZE].C_RMAX + subset[CELL_SIZE].C_Y_CENTER;
						if(b < 0)	b=-b;
						if(a < b)	a = b;
					b = -subset[CELL_SIZE].C_RMAX + subset[CELL_SIZE].C_Y_CENTER;
						if(b < 0)	b=-b;
						if(a < b)	a = b;
					break;
				}
			case SPHERICAL:
				{
					a = subset[CELL_SIZE].SP_X_CENTER + subset[CELL_SIZE].SP_RMAX;
					if(a < 0)	a = -a;
					b = -subset[CELL_SIZE].SP_RMAX + subset[CELL_SIZE].SP_X_CENTER;
					if(b < 0)	b = -b;
					if(a < b)	a = b;
					b = subset[CELL_SIZE].SP_RMAX + subset[CELL_SIZE].SP_Y_CENTER;
					if(b < 0)	b = -b;
					if(a < b)	a = b;
					b = -subset[CELL_SIZE].SP_RMAX + subset[CELL_SIZE].SP_Y_CENTER;
					if(b < 0)	b = -b;
					if(a < b)	a = b;
					b = subset[CELL_SIZE].SP_RMAX + subset[CELL_SIZE].SP_Z_CENTER;
					if(b < 0)	b = -b;
					if(a < b)	a = b;
					b = -subset[CELL_SIZE].SP_RMAX + subset[CELL_SIZE].SP_Z_CENTER;
					if(b < 0)	b = -b;
					if(a < b)	a = b;
					break;
				}
			default:
					a =10.;
		}
	a = 2.*a;
	b = Lattice_D[0];
	if(b < Lattice_D[1])	b = Lattice_D[1];
	if(b < Lattice_D[2])	b = Lattice_D[2];
	if(b <= 0)	b = 1.;

	Cell_Size_Param = (int)(a/b) + 2;
	if(Cell_Size_Param < 0)
		Cell_Size_Param = 10;
	}

void	Set_Cell_Size(void)
	{
		float a,b;
		int i;
		if(Total_Atoms > 0)
			{
				atom_ptr=atom_ptr_temp;
				a=atom_ptr->XC;	b=a;
				for(i=0; i<Total_Atoms; i++)
					{
						if(atom_ptr->XC > b)
							b=atom_ptr->XC;
						if(atom_ptr->XC < a)
							a=atom_ptr->XC;
						atom_ptr++;
					}
				a=(float)((int)(a-1.));
				b=(float)((int)(b+1.));
				subset[CELL_SIZE].XMIN = a;
				subset[CELL_SIZE].XMAX = b;

				atom_ptr=atom_ptr_temp;
				a=atom_ptr->YC;	b=a;
				for(i=0; i<Total_Atoms; i++)
					{
						if(atom_ptr->YC > b)
							b=atom_ptr->YC;
						if(atom_ptr->YC < a)
							a=atom_ptr->YC;
						atom_ptr++;
					}
				a=(float)((int)(a-1.));
				b=(float)((int)(b+1.));
				subset[CELL_SIZE].YMIN = a;
				subset[CELL_SIZE].YMAX = b;

				atom_ptr=atom_ptr_temp;
				a=atom_ptr->ZC;	b=a;
				for(i=0; i<Total_Atoms; i++)
					{
						if(atom_ptr->ZC > b)
							b=atom_ptr->ZC;
						if(atom_ptr->ZC < a)
							a=atom_ptr->ZC;
						atom_ptr++;
					}
				a=(float)((int)(a-1.));
				b=(float)((int)(b+1.));
				subset[CELL_SIZE].ZMIN = a;
				subset[CELL_SIZE].ZMAX = b;
			}
	}



int menu_periodicity (PULLDOWN_MENU_PTR p, BAR_MENU_PTR b1,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)

	{
	 int	i;

	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 planes_and_periodicity();
	 WindowClear(pw);
	 WindowHide(pw, NOEFFECT);
	 return(PULLDOWN_EXIT);
	}


int menu_h_junction(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {
  int i;

  if(Total_Atoms <= 0)
	{
     WindowClear(pw);
	  WindowDisplay(pw,1,NOEFFECT);
     WindowPrintf(pw,"No cell created or read in\n");
     WindowPrintf(pw,"\nHit any key to continue ...");
     i=getch();
     WindowHide(pw,NOEFFECT);
     return(PULLDOWN_EXIT);
   }

  if(Current_Atom_Type < 0)
   {
     WindowClear(pw);
     WindowDisplay(pw,1,NOEFFECT);
     WindowPrintf(pw,"No atom type is selected\n");
     WindowPrintf(pw,"\nHit any key to continue ...");
     i=getch();
     WindowHide(pw,NOEFFECT);
     return(PULLDOWN_EXIT);
   }

   atom_ptr=atom_ptr_temp;
	i=0;
   while(i<Total_Atoms)
    {
     if(check_within_subset(atom_ptr->XC,
			    atom_ptr->YC,
			    atom_ptr->ZC,
				 H_STRUCT) == DESH_IN_SIDE)
	  {
	   atom_ptr->TYPE = Current_Atom_Type;
	  }
     i++;
     atom_ptr++;
    }
   File_Modification = DESH_YES;
	return(PULLDOWN_EXIT);
 }


int menu_retain_subset(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		int i,j;
		int Vacancy_Save;
		struct atom_specs *subset_atom_ptr;

		atom_ptr=atom_ptr_temp;
		subset_atom_ptr=atom_ptr;

		if(Total_Atoms <= 0)
			{
				WindowClear(pw);
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n No cell constructed or read from file");
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
				return(PULLDOWN_CONTINUE);
			}
				WindowClear(pw);
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n Retain vacancies in the cell (Y/N) ? ");
				i=0;
				while((i != 'Y') && (i != 'y') && (i != 'N') && (i != 'n'))
					{
						i=getch();
					}
				Vacancy_Save = DESH_NO;
				if((i == 'Y') || (i == 'y'))
					Vacancy_Save = DESH_YES;
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);

		j=0;
		for(i=0; i<Total_Atoms; i++)
			{
				if(check_within_subset(subset_atom_ptr->XC,
												subset_atom_ptr->YC,
												subset_atom_ptr->ZC,
												R_ATOMS) == DESH_IN_SIDE)
					{
						if((subset_atom_ptr->TYPE == VACANCY) &&
							(Vacancy_Save == DESH_NO))
								{
									subset_atom_ptr++;
									continue;
								}
						atom_ptr->XC = subset_atom_ptr->XC;
						atom_ptr->YC = subset_atom_ptr->YC;
						atom_ptr->ZC = subset_atom_ptr->ZC;
						atom_ptr->TYPE = subset_atom_ptr->TYPE;
						atom_ptr->PLANE = subset_atom_ptr->PLANE;
						j++;
						atom_ptr++;
					}
				subset_atom_ptr++;
			}

		Total_Atoms = j;
		File_Modification = DESH_YES;
		if(Total_Atoms <= 0)
			{
				WindowClear(pw);
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n There were no atoms in the subset");
				WindowPrintf(pw, "\n There is no computational cell");
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw, NOEFFECT);
				return(PULLDOWN_CONTINUE);
			}

		return(PULLDOWN_CONTINUE);
	}


int menu_energy(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		p_energy_items = PopupCreateMenu(subset_energy_items,
				  menu_colors,
			     4,10,2,
			     POPUPWRAP | POPUPSTATIC,
			     WNULLFN, VWNULLFN);
		PopupSelectMenu( p_energy_items, 1, 1);
		PopupMenuFree( p_energy_items);
		return(PULLDOWN_EXIT);
	}

int menu_boundaries(POPUP_MENU_PTR p, unsigned which)
	{
	 int i, j, k;
	 float xmin, xmax, ymin, ymax, zmin, zmax;

	 if(Total_Atoms <= 0)
	  {
	   WindowDisplay(pw, 1, NOEFFECT);
	   WindowPrintf(pw, "\nNo cell created or read from a file \n");
	   WindowPrintf(pw, "Hit any key to continue ....");
		i= getch();
	   WindowHide(pw,NOEFFECT);
	   return(POPUP_EXIT);
	  }


	 xmin = 10000.;		ymin = 10000.; 		zmin = 10000.;
	 xmax = -xmin;		ymax =	-ymin;		zmax = -zmin;
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 while(i < Total_Atoms)
	  {
	   if(atom_ptr->XC < xmin)
	    xmin = atom_ptr->XC;
	   if(atom_ptr->XC > xmax)
	    xmax = atom_ptr->XC;
		if(atom_ptr->YC < ymin)
	    ymin = atom_ptr->YC;
	   if(atom_ptr->YC > ymax)
	    ymax = atom_ptr->YC;
		if(atom_ptr->ZC < zmin)
	    zmin = atom_ptr->ZC;
	   if(atom_ptr->ZC > zmax)
	    zmax = atom_ptr->ZC;
	    atom_ptr++;
	    i++;
	   }

	Cell_Dimension[0] = xmax - xmin;
	Cell_Dimension[1] = ymax - ymin;
	Cell_Dimension[2] = zmax - zmin;



	boundary_menu_array=PopupAllocate(BOUNDARY_PARAM);

	  i=0;
	  while(i<3)
		{
		 if(Periodicity[i] == 0)
		  sprintf(Boundary_Menu_Entry[i], "%c : Non Periodic ", XYZ[i]);
		 else
		  sprintf(Boundary_Menu_Entry[i], "%c : Period %7.2f", XYZ[i],
				Neb_Periodic_Block[i]);
		 PopupCreateEntry(boundary_menu_array, i+1,
			 Boundary_Menu_Entry[i],
			 i+1, 0, 0, input_boundary_TYPE);
		 i++;
		}

	PopupEntryEnd(boundary_menu_array, BOUNDARY_PARAM);
	p_boundary = PopupCreateMenu(boundary_menu_array,
				  menu_colors,
				  9,3,3,
				  POPUPWRAP | POPUPSTATIC,
				  WNULLFN, VWNULLFN);

	PopupSelectMenu( p_boundary, 1, 1);
	PopupDeallocate( boundary_menu_array);
	return(POPUP_EXIT);
 }



int	input_boundary_TYPE(POPUP_MENU_PTR p, unsigned which)
	{
	 int i;

	 Selected_Axis = which - 1;
		p_select_boundary = PopupCreateMenu(select_boundary_items,
			     menu_colors,
			     12,25,2,
			     POPUPWRAP | POPUPSTATIC,
			     WNULLFN, VWNULLFN);
		PopupSelectMenu( p_select_boundary, 1, 1);
		PopupMenuFree( p_select_boundary);
	 return(POPUP_CONTINUE);
	}



int	set_boundary(POPUP_MENU_PTR p, unsigned which)
	{

	 int i, j;
	 char temp[50];

	 if(which == 1)
	  {
		Periodicity[Selected_Axis] = 0;
		Neb_Periodic_Block[Selected_Axis] = 10000.;
		sprintf(temp, "%c : Non Periodic ", XYZ[Selected_Axis]);
		PopupChangeEntryString(p_boundary,
		Selected_Axis+1, temp);
	  }
	 else
	  {
		Periodicity[Selected_Axis] = 1;
		  j=0;
		  while((j < 1000) &&
			(j * Periodic_Planes[Selected_Axis] < Total_Planes[Selected_Axis]))
			{
			 j++;
			}
		  Neb_Periodic_Block[Selected_Axis] =
		(float)j * Periodic_Block[Selected_Axis];

		 WindowClear(pw);
		 WindowDisplay(pw, 1, EXPLODE);
		 WindowPrintf(pw, "\n Along %c cell has %3d planes",
			XYZ[Selected_Axis], Total_Planes[Selected_Axis]);
		 WindowPrintf(pw, "\n A block of %3d planes is periodic",
			Periodic_Planes[Selected_Axis]);
		 if(Periodic_Planes[Selected_Axis]*j != Total_Planes[Selected_Axis])
			WindowPrintf(pw, "\n Cell size is not a multiple of periodic block");
		 else
			WindowPrintf(pw, "\n Cell size is a periodic block");
		 WindowPrintf(pw, "\n Periodic block = %6.2f ? ", Neb_Periodic_Block[Selected_Axis]);
		 Neb_Periodic_Block[Selected_Axis] =
			get_float(Neb_Periodic_Block[Selected_Axis]);
		  sprintf(temp, "%c : Period %7.2f",
		XYZ[Selected_Axis], Neb_Periodic_Block[Selected_Axis]);
		 WindowHide(pw, NOEFFECT);

		  PopupChangeEntryString(p_boundary, Selected_Axis+1, temp);
	  }
	 return(POPUP_EXIT);
	}



int menu_compute_cell_energy(POPUP_MENU_PTR p, unsigned which)
 {
	compute_cell_energy();
	return(POPUP_CONTINUE);
 }


int menu_rotate_cell(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b1,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
 {
  int i,j,k;
  float a,b,c,d,e,f;
	  WindowClear(pw);
     WindowDisplay(pw,1,NOEFFECT);

  if(Total_Atoms <= 0)
	{
	  WindowPrintf(pw,"No cell read in or constructed ");
	  WindowPrintf(pw,"\n  Hit any key to continue ...");
	  i=getch();
	  WindowHide(pw,NOEFFECT);
	  return(PULLDOWN_CONTINUE);
	}

  File_Modification = DESH_YES;
  atom_ptr=atom_ptr_temp;
  i=0;
  while(i<Total_Atoms)
	{
    a=atom_ptr->XC;
    b=atom_ptr->YC;
    c=atom_ptr->ZC;


    d=f_rotate[0][0]*a+f_rotate[0][1]*b+f_rotate[0][2]*c;
    e=f_rotate[1][0]*a+f_rotate[1][1]*b+f_rotate[1][2]*c;
    f=f_rotate[2][0]*a+f_rotate[2][1]*b+f_rotate[2][2]*c;

	 atom_ptr->XC = d;
    atom_ptr->YC = e;
    atom_ptr->ZC = f;

	 atom_ptr++;
    i++;
   }

	 i=0;
    while(i<3)
	  {
      for(j=0; j<3; j++)
       {
	current_axes[i][j] = rotate_axes[i][j];
	current_basis_vector[i][j] = rotate_basis_vector[i][j];
		 }
      i++;
     }


	 WindowPrintf(pw,"Sorting the atoms .....");
    planes_and_periodicity();
    WindowPrintf(pw,"\n Hit any key to continue ....");
	 i=getch();
	 WindowHide(pw,NOEFFECT);
	 return(PULLDOWN_EXIT);
  }







int menu_relax(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
	 int i;
	 relax_menu_array=PopupAllocate(RELAX_ENTRIES);

	 sprintf(Relax_Entry[0], "%s   %7.4f", Relax_Phrases[0], Delta_R);
	 PopupCreateEntry(relax_menu_array, 1, Relax_Entry[0],
			1, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[1], "%s   %7.4f", Relax_Phrases[1], Delta_Energy);
	 PopupCreateEntry(relax_menu_array, 2, Relax_Entry[1],
			2, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[2], "%s   %d", Relax_Phrases[2], Iterations);
	 PopupCreateEntry(relax_menu_array, 3, Relax_Entry[2],
			3, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[3], "%s   ", Relax_Phrases[3]);
	 PopupCreateEntry(relax_menu_array, 4, Relax_Entry[3],
			4, 0, 0, menu_Energy_Minimization);

	 sprintf(Relax_Entry[4], "%s   %d", Relax_Phrases[4], Temperature);
	 PopupCreateEntry(relax_menu_array, 5, Relax_Entry[4],
			5, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[5], "%s   ", Relax_Phrases[5]);
	 PopupCreateEntry(relax_menu_array, 6, Relax_Entry[5],
			6, 0, 0, menu_MC_Plot);

	 sprintf(Relax_Entry[6], "%s   ", Relax_Phrases[6]);
	 PopupCreateEntry(relax_menu_array, 7, Relax_Entry[6],
			7, 0, 0, menu_Monte_Carlo);

	 sprintf(Relax_Entry[7], "%s   %6.2f", Relax_Phrases[7], MC_Bias_Value);
	 PopupCreateEntry(relax_menu_array, 8, Relax_Entry[7],
			8, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[8], "%s   ", Relax_Phrases[8]);
	 PopupCreateEntry(relax_menu_array, 9, Relax_Entry[8],
			9, 0, 0, menu_SA);

	 sprintf(Relax_Entry[9], "%s   %d", Relax_Phrases[9], SA_Temp_Step);
	 PopupCreateEntry(relax_menu_array, 10, Relax_Entry[9],
			10, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[10], "%s   %d", Relax_Phrases[10], SA_Final_Temp);
	 PopupCreateEntry(relax_menu_array, 11, Relax_Entry[10],
			11, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[11], "%s   ", Relax_Phrases[11]);
	 PopupCreateEntry(relax_menu_array, 12, Relax_Entry[11],
			12, 0, 0, menu_atom_swap);

	 sprintf(Relax_Entry[12], "%s   %6.2f", Relax_Phrases[12],
						Swap_Relax_Sphere_Radius);
	 PopupCreateEntry(relax_menu_array, 13, Relax_Entry[12],
			13, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[13], "%s   %6.2f", Relax_Phrases[13],
						Swap_Nearest_Neb_Dist);
	 PopupCreateEntry(relax_menu_array, 14, Relax_Entry[13],
			14, 0, 0, input_relax_param);

	 sprintf(Relax_Entry[14], "%s   ", Relax_Phrases[14]);
	 PopupCreateEntry(relax_menu_array, 15, Relax_Entry[14],
			15, 0, 0, menu_atom_swap);

	 PopupEntryEnd(relax_menu_array, RELAX_ENTRIES);
	 p_relax = PopupCreateMenu(relax_menu_array,
					menu_colors,
					5,5,RELAX_ENTRIES,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
	 PopupSelectMenu(p_relax, 1, 1);
	 PopupDeallocate(relax_menu_array);
	 WindowClear(pw);
	 return(PULLDOWN_EXIT);
	}

int	input_relax_param(POPUP_MENU_PTR p, unsigned which)
	{
	 char temp[50];
	 int i;
	 float	a;

	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 WindowPrintf(pw, "%s ? ", Relax_Phrases[which-1]);

	 if(which == 1)
		{
		Delta_R = get_float(Delta_R);
		sprintf(temp, "%s   %7.4f",Relax_Phrases[which-1],Delta_R);
		PopupChangeEntryString(p_relax, which, temp);
		}
	 if(which == 2)
		{
		a = get_float(Delta_Energy);
		if(a > 0.)
			{
				Delta_Energy=a;
				sprintf(temp, "%s   %7.4f",Relax_Phrases[which-1],Delta_Energy);
				PopupChangeEntryString(p_relax, which, temp);
			}
		}
	 if(which == 3)
		{
		i = get_integer(Iterations);
		if(i > 0)
			{
				Iterations = i;
				sprintf(temp, "%s   %d",Relax_Phrases[which-1],Iterations);
				PopupChangeEntryString(p_relax, which, temp);
			}
		}
	 if(which == 5)
		{
		i = get_integer(Temperature);
		if(i >= 0)
			{
				Temperature = i;
				sprintf(temp, "%s   %d",Relax_Phrases[which-1],Temperature);
				PopupChangeEntryString(p_relax, which, temp);
			}
		}
	 if(which == 8)
		{
		a = get_float(MC_Bias_Value);
		if((a>= 0.) && (a <= 1.))
			{
				MC_Bias_Value = a;
				sprintf(temp, "%s   %6.2f",Relax_Phrases[which-1],MC_Bias_Value);
				PopupChangeEntryString(p_relax, which, temp);
			}
		}
	 if(which == 10)
		{
		SA_Temp_Step = get_integer(SA_Temp_Step);
		sprintf(temp, "%s   %d",Relax_Phrases[which-1], SA_Temp_Step);
		PopupChangeEntryString(p_relax, which, temp);
		}
	 if(which == 11)
		{
		SA_Final_Temp = get_integer(SA_Final_Temp);
		sprintf(temp, "%s   %d",Relax_Phrases[which-1], SA_Final_Temp);
		PopupChangeEntryString(p_relax, which, temp);
		}
	 if(which == 13)
		{
		a = get_float(Swap_Relax_Sphere_Radius);
		if(a >= 0.)
			{
				Swap_Relax_Sphere_Radius = a;
				sprintf(temp, "%s   %6.2f",Relax_Phrases[which-1], Swap_Relax_Sphere_Radius);
				PopupChangeEntryString(p_relax, which, temp);
			}
		}
	 if(which == 14)
		{
		a = get_float(Swap_Nearest_Neb_Dist);
		if(a >= 0.)
			{
				Swap_Nearest_Neb_Dist = a;
				sprintf(temp, "%s   %6.2f",Relax_Phrases[which-1], Swap_Nearest_Neb_Dist);
				PopupChangeEntryString(p_relax, which, temp);
			}
		}
	 WindowHide(pw, NOEFFECT);
	 return(POPUP_CONTINUE);
	}


int	menu_SA(POPUP_MENU_PTR p, unsigned which)
	{
		Simulated_Annealing();
		return(POPUP_CONTINUE);
	}

int	menu_atom_swap(POPUP_MENU_PTR p, unsigned which)
	{
		if(which == 14)
			Swap_Mode=DESH_DIFFUSION;
		else
			Swap_Mode=DESH_RANDOM_SWAP;
		Atom_Swap_Minimization();
		return(POPUP_CONTINUE);
	}


int	menu_Energy_Minimization(POPUP_MENU_PTR p, unsigned which)
	{
		Energy_Minimization();
		return(POPUP_CONTINUE);
	}

int	menu_Monte_Carlo(POPUP_MENU_PTR p, unsigned which)
	{
		Monte_Carlo();
		return(POPUP_CONTINUE);
	}

int menu_MC_Plot(POPUP_MENU_PTR p, unsigned which)
	{
	 int i;
	 mc_plot_menu_array=PopupAllocate(MC_PLOT_ENTRIES);
	 sprintf(MC_Plot_Entry[0], "%s   %7.1f", MC_Plot_Phrases[0], MC_Plot_Xmin);
	 PopupCreateEntry(mc_plot_menu_array, 1, MC_Plot_Entry[0],
			1, 0, 0, input_MC_Plot_param);

	 sprintf(MC_Plot_Entry[1], "%s   %7.1f", MC_Plot_Phrases[1], MC_Plot_Xmax);
	 PopupCreateEntry(mc_plot_menu_array, 2, MC_Plot_Entry[1],
			2, 0, 0, input_MC_Plot_param);

	 sprintf(MC_Plot_Entry[2], "%s   %7.1f", MC_Plot_Phrases[2], MC_Plot_Ymin);
	 PopupCreateEntry(mc_plot_menu_array, 3, MC_Plot_Entry[2],
			3, 0, 0, input_MC_Plot_param);

	 sprintf(MC_Plot_Entry[3], "%s   %7.1f", MC_Plot_Phrases[3], MC_Plot_Ymax);
	 PopupCreateEntry(mc_plot_menu_array, 4, MC_Plot_Entry[3],
			4, 0, 0, input_MC_Plot_param);

	 sprintf(Relax_Entry[4], "%s  ", MC_Plot_Phrases[4]);
	 PopupCreateEntry(mc_plot_menu_array, 5, Relax_Entry[4],
			5, 0, 0, menu_MC_Energy_Plot);

	 PopupEntryEnd(mc_plot_menu_array, MC_PLOT_ENTRIES);
	 p_mc_plot = PopupCreateMenu(mc_plot_menu_array,
					menu_colors,
					12,30,MC_PLOT_ENTRIES,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
	 PopupSelectMenu(p_mc_plot, 1, 1);
	 PopupDeallocate(mc_plot_menu_array);
	 WindowClear(pw);
	 return(PULLDOWN_EXIT);
	}

int	menu_MC_Energy_Plot(POPUP_MENU_PTR p, unsigned which)
	{
		MC_Energy_Plot();
		return(POPUP_CONTINUE);
	}

int	input_MC_Plot_param(POPUP_MENU_PTR p, unsigned which)
	{
	 char temp[50];

	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 WindowPrintf(pw, "%s ? ", MC_Plot_Phrases[which-1]);

	 if(which == 1)
		{
		 MC_Plot_Xmin = get_float(MC_Plot_Xmin);
		 sprintf(temp, "%s   %7.1f", MC_Plot_Phrases[which-1], MC_Plot_Xmin);
		 PopupChangeEntryString(p_mc_plot, which, temp);
		}
	 if(which == 2)
		{
		 MC_Plot_Xmax = get_float(MC_Plot_Xmax);
		 if(MC_Plot_Xmax > MAX_MC_ENERGIES)
			MC_Plot_Xmax=MAX_MC_ENERGIES;
		 sprintf(temp, "%s   %7.1f", MC_Plot_Phrases[which-1], MC_Plot_Xmax);
		 PopupChangeEntryString(p_mc_plot, which, temp);
		}
	 if(which == 3)
		{
		 MC_Plot_Ymin = get_float(MC_Plot_Ymin);
		 sprintf(temp, "%s   %7.1f", MC_Plot_Phrases[which-1], MC_Plot_Ymin);
		 PopupChangeEntryString(p_mc_plot, which, temp);
		}
	 if(which == 4)
		{
		 MC_Plot_Ymax = get_float(MC_Plot_Ymax);
		 sprintf(temp, "%s   %7.1f", MC_Plot_Phrases[which-1], MC_Plot_Ymax);
		 PopupChangeEntryString(p_mc_plot, which, temp);
		}
	 WindowHide(pw, NOEFFECT);
	 return(POPUP_CONTINUE);
	}



int menu_GB(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
	 int i;
	 GB_menu_array=PopupAllocate(GB_ENTRIES);

	 sprintf(GB_Entry[0], "%s   %7.4f", GB_Phrases[0], GB_Angle);
	 PopupCreateEntry(GB_menu_array, 1, GB_Entry[0],
			1, 0, 0, input_GB_param);

	 sprintf(GB_Entry[1], "%s   %7.4f", GB_Phrases[1], GB_Core_Width);
	 PopupCreateEntry(GB_menu_array, 2, GB_Entry[1],
			2, 0, 0, input_GB_param);

	 sprintf(GB_Entry[2], "%s   ", GB_Phrases[2]);
	 PopupCreateEntry(GB_menu_array, 3, GB_Entry[2],
			3, 0, 0, Make_GB);

	 sprintf(GB_Entry[3], "%s   ", GB_Phrases[3]);
	 PopupCreateEntry(GB_menu_array, 4, GB_Entry[3],
			4, 0, 0, Make_GB_Core);

	 PopupEntryEnd(GB_menu_array, GB_ENTRIES);
	 p_GB = PopupCreateMenu(GB_menu_array,
			     menu_colors,
				  9,3,4,
			     POPUPWRAP | POPUPSTATIC,
			     WNULLFN, VWNULLFN);
	 PopupSelectMenu(p_GB, 1, 1);
	 PopupDeallocate(GB_menu_array);
	 return(PULLDOWN_EXIT);
	}


int	input_GB_param(POPUP_MENU_PTR p, unsigned which)
	{
	 char temp[50];

	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 WindowPrintf(pw, "%s ? ", GB_Phrases[which-1]);

	 if(which == 1)
	  {
		GB_Angle = get_float(GB_Angle);
		sprintf(temp, "%s   %7.4f",GB_Phrases[which-1],GB_Angle);
	   PopupChangeEntryString(p_GB, which, temp);
	  }
	 if(which == 2)
	  {
	   GB_Core_Width = get_float(GB_Core_Width);
	   sprintf(temp, "%s   %7.4f",GB_Phrases[which-1],GB_Core_Width);
	   PopupChangeEntryString(p_GB, which, temp);
	  }
	 WindowHide(pw, NOEFFECT);
	 return(POPUP_CONTINUE);
	}

int	Make_GB(POPUP_MENU_PTR p, unsigned which)
	{
	 int i, GB_Atoms;
	 double angle;
	 float cos_angle, sin_angle;
	 float x_new, y_new;
	 struct atom_specs *gb_atom_ptr;
	 if(Total_Atoms < 1)
	  {
	    WindowClear(pw);
	    WindowDisplay(pw,1,EXPLODE);
	    WindowPrintf(pw,"\n No cell created or read in\n\n");
	    WindowPrintf(pw, " Hit ant key to continue ....");
	    i=getch();
	    WindowClear(pw);
	    WindowHide(pw,NOEFFECT);
	    return(POPUP_CONTINUE);
	  }

    File_Modification = DESH_YES;
	 angle = (double)GB_Angle * PI / 180.;
	 angle = 0.5 * angle;
	 cos_angle = (float) cos (angle);
	 sin_angle = (float) sin (angle);
	 gb_atom_ptr = atom_ptr_temp;
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 GB_Atoms = 0;
	 while(i < Total_Atoms)
	   {
	     x_new = atom_ptr->XC * cos_angle -
		     atom_ptr->YC * sin_angle;
	     y_new = atom_ptr->YC * cos_angle +
		     atom_ptr->XC * sin_angle;
	     if( x_new <= GB_Core_Width/2.0)
	      {
		gb_atom_ptr->XC = x_new;
		gb_atom_ptr->YC = y_new;
		gb_atom_ptr->ZC = atom_ptr->ZC;
		gb_atom_ptr->TYPE = atom_ptr->TYPE;
		gb_atom_ptr->PLANE = atom_ptr->PLANE;
		GB_Atoms++;
		gb_atom_ptr++;
	      }
	    i++;
	    atom_ptr++;
	   }
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 Total_Atoms = GB_Atoms;
	 while(i < GB_Atoms)
	  {
	    if(atom_ptr->XC < -GB_Core_Width/2.0)
	     {
		gb_atom_ptr->XC = -atom_ptr->XC;
		gb_atom_ptr->YC = atom_ptr->YC;
		gb_atom_ptr->ZC = atom_ptr->ZC;
		gb_atom_ptr->TYPE = atom_ptr->TYPE;
		gb_atom_ptr->PLANE = atom_ptr->PLANE;
		Total_Atoms++;
		gb_atom_ptr++;
	     }
	 atom_ptr++;
	 i++;
	 }
	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 WindowPrintf(pw,"\n\nGrain boundary constructed\nHit any key to continue ....");
	 GB_Constructed = DESH_YES;
	 i=getch();
	 WindowClear(pw);
	 WindowHide(pw,NOEFFECT);
	 return(POPUP_CONTINUE);
	}






int	Make_GB_Core(POPUP_MENU_PTR p, unsigned which)
	{
	 float ymin, ymax, xmin, xmax;
	 float x_center, y_center, scale_factor;
	 int i, j, maxx, maxy, min_pixle, border_size, rad_pixle;
	 int x_left, x_right, y_top, y_bottom;
	 int Action_Valid, GB_Atoms;
	 char temp[40];
	 int	ht;

	 struct atom_specs *atom_ptr_bottom;

	 if((Graphics_Error == DESH_YES) || (Total_Atoms <= 0))
	  {
		 WindowClear(pw);
		 WindowDisplay(pw,1,EXPLODE);
		 WindowPrintf(pw,"\n No GB created or read in? or\n\n");
		 WindowPrintf(pw,"\n No graphic adapter? \n\n");
		 WindowPrintf(pw, " Hit ant key to continue ....");
	    i=getch();
	    WindowClear(pw);
	    WindowHide(pw,NOEFFECT);
		 return(POPUP_CONTINUE);
	  }


	 File_Modification = DESH_YES;

	 ymin = atom_ptr->YC;
	 ymax = atom_ptr->YC;
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 while(i < Total_Atoms)
	  {
		if(ymin > atom_ptr->YC) ymin = atom_ptr->YC;
	   if(ymax < atom_ptr->YC) ymax = atom_ptr->YC;
		atom_ptr++;
		i++;
	  }
	 xmax = (ymax-ymin)/2.;
	 xmin = -xmax;

	 setgraphmode(getgraphmode());
	 maxx=getmaxx();	maxy=getmaxy();
	 if(maxx < maxy)min_pixle = maxx;
	 if(maxx > maxy)min_pixle = maxy;
	 border_size = 0.05*min_pixle;

	 scale_factor = (min_pixle - 2*border_size) / (xmax - xmin);

	 atom_ptr = atom_ptr_temp;
	 i=0;
	 while(i < Total_Atoms)
	  {
		if((atom_ptr->XC < xmin) || (atom_ptr->XC > xmax)  ||
			( (atom_ptr->XC >= -GB_Core_Width/2.) &&
			  (atom_ptr->XC <= GB_Core_Width/2.))    )
		 {
		  i++;
		  atom_ptr++;
		  continue;
		 }
		x_center = border_size+(int)(scale_factor*(atom_ptr->XC-xmin));
		y_center = min_pixle-border_size-
				(int)(scale_factor*(atom_ptr->YC-ymin));
		rad_pixle=(int)(scale_factor*Element[atom_ptr->TYPE].Radius);
		setfillstyle(SOLID_FILL, atom_ptr->PLANE);
		fillellipse(x_center, y_center, rad_pixle, rad_pixle);
		i++;
		atom_ptr++;
		}

	  i=getch();

	 atom_ptr = atom_ptr_temp;
	 setfillstyle(SOLID_FILL, RED);
	 i=0;
	 while(i < Total_Atoms)
	  {
		if((atom_ptr->XC >= -GB_Core_Width/2.) &&
			(atom_ptr->XC <= GB_Core_Width/2.))
		 {
			x_center = border_size+(int)(scale_factor*(atom_ptr->XC-xmin));
			y_center = min_pixle-border_size-
				(int)(scale_factor*(atom_ptr->YC-ymin));
			rad_pixle=(int)(scale_factor*Element[atom_ptr->TYPE].Radius);
			fillellipse(x_center, y_center, rad_pixle, rad_pixle);
		 }
		atom_ptr++;
		i++;
	 }

	x_left = border_size + (int)(scale_factor * (-GB_Core_Width/2. - xmin));
	y_top =  border_size;
	x_right = border_size + (int)(scale_factor * (GB_Core_Width/2. - xmin));
	y_bottom = min_pixle - border_size;
	setcolor(WHITE);
	rectangle(x_left, y_top, x_right, y_bottom);

	x_right = border_size + (int)(scale_factor * (-xmin));
	rectangle(x_left, y_top, x_right, y_bottom);

	atom_ptr_bottom = atom_ptr_temp;
	for(i = 0; i < Total_Atoms; atom_ptr_bottom++, i++);
	GB_Atoms = Total_Atoms;
	atom_ptr = atom_ptr_temp;

	i=0;
	while(i < Total_Atoms)
	 {
		if((atom_ptr->XC >= -GB_Core_Width/2.) &&
		  (atom_ptr->XC <= GB_Core_Width/2.))
			{
				setfillstyle(SOLID_FILL, YELLOW);
				x_center = border_size+(int)(scale_factor*(atom_ptr->XC-xmin));
				y_center = min_pixle-border_size-
							(int)(scale_factor*(atom_ptr->YC-ymin));
				rad_pixle=(int)(scale_factor*Element[atom_ptr->TYPE].Radius);
				fillellipse(x_center, y_center, rad_pixle, rad_pixle);
				ht = textheight("W");
					sprintf(temp, "D : Delete");
					outtextxy(maxx-20*ht, 1*ht, temp);
					sprintf(temp, "R : Reflect");
					outtextxy(maxx-20*ht, 3*ht, temp);
					sprintf(temp, "M : Move to Center");
					outtextxy(maxx-20*ht, 5*ht, temp);
					sprintf(temp, "K : Keep");
					outtextxy(maxx-20*ht, 7*ht, temp);

				Action_Valid = DESH_NO;
				while(Action_Valid == DESH_NO)
				 {


				  j = getch();
				  switch (j)
					{
						case DESH_D:
						case DESH_d:
						 {
						  setfillstyle(SOLID_FILL, BLACK);
						  fillellipse(x_center, y_center, rad_pixle, rad_pixle);
						  atom_ptr->TYPE = -1;
						  Action_Valid = DESH_YES;
						  break;
						 }

						case DESH_K:
						case DESH_k:
						 {
						  setfillstyle(SOLID_FILL, atom_ptr->PLANE);
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
						  Action_Valid = DESH_YES;
						  break;
						 }

						case DESH_M:
						case DESH_m:
						 {
						  setfillstyle(SOLID_FILL, BLACK);
						  fillellipse(x_center, y_center, rad_pixle, rad_pixle);
							  atom_ptr->XC = 0.;
						  x_center = min_pixle/2;
						  setfillstyle(SOLID_FILL, atom_ptr->PLANE);
						  fillellipse(x_center, y_center, rad_pixle, rad_pixle);
						  Action_Valid = DESH_YES;
						  break;
						 }

						case DESH_R:
						case DESH_r:
						 {
						  setfillstyle(SOLID_FILL, atom_ptr->PLANE);
						  fillellipse(x_center, y_center, rad_pixle, rad_pixle);
						  atom_ptr_bottom->XC = -atom_ptr->XC;
						  atom_ptr_bottom->YC = atom_ptr->YC;
						  atom_ptr_bottom->ZC = atom_ptr->ZC;
						  atom_ptr_bottom->TYPE = atom_ptr->TYPE;
						  atom_ptr_bottom->PLANE = -atom_ptr->PLANE;
						  x_center = border_size +
									(int)(scale_factor*(atom_ptr_bottom->XC-xmin));
						  fillellipse(x_center, y_center, rad_pixle, rad_pixle);
						  atom_ptr_bottom++;
						  GB_Atoms++;
						  Action_Valid = DESH_YES;
						  break;
						 }


						default:
						 {
							Action_Valid = DESH_NO;
							  break;
						 }

					}
				 }
			}
		  if(GB_Atoms >= MAX_ATOMS)
			{
			 moveto(min_pixle + 2*border_size, min_pixle/2);
			 outtext("Exceeded atom limits");
			 j=getch();
			 break;
			}
		  atom_ptr++;
		  i++;
	 }

	 i=0;
	 atom_ptr = atom_ptr_temp;
	 atom_ptr_bottom = atom_ptr_temp;
	 Total_Atoms=0;
	 while(i < GB_Atoms)
	  {
		if(atom_ptr_bottom->TYPE >= 0)
		 {
		  if(atom_ptr != atom_ptr_bottom)
			{
			 atom_ptr->XC = atom_ptr_bottom->XC;
			 atom_ptr->YC = atom_ptr_bottom->YC;
			 atom_ptr->ZC = atom_ptr_bottom->ZC;
			 atom_ptr->TYPE = atom_ptr_bottom->TYPE;
			 atom_ptr->PLANE = atom_ptr_bottom->PLANE;
			}
		  atom_ptr++;
		  Total_Atoms++;
		}
	  atom_ptr_bottom++;
	  i++;
	 }

	 i=getch();
	 restorecrtmode();
	 clrscr();
	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 atom_ptr=atom_ptr_temp;
	 WindowPrintf(pw,"%d Atoms read from the file ",Total_Atoms);

	 WindowPrintf(pw,"\nSorting the atoms .....");
    planes_and_periodicity();
    WindowPrintf(pw,"\n Hit any key to continue ....");
	 i=getch();
    WindowHide(pw,NOEFFECT);

	 return(POPUP_EXIT);
	}


int menu_cell_extend(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		int		i,j;
		int		atoms_added, revised_total_atoms;
		float	a, Z_Front, Z_Back;
		float	block_no, p_block;
		struct atom_specs *atom_ptr_bottom;
		int		Z_Axis = 2;

		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);

		if(Total_Atoms <= 0)
			{
				WindowPrintf(pw, "\n No cell created or read in");
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
				WindowClear(pw);
				WindowHide(pw,NOEFFECT);
				return(POPUP_CONTINUE);
			}

/* Is the current cell a periodic block ? */

		  j=0;
		  while((j < 1000) &&
			(j * Periodic_Planes[Z_Axis] < cell_planes))
			{
			 j++;
			}
		  p_block = (float)j * Periodic_Block[Z_Axis];
			 WindowPrintf(pw, "\n Along %c cell has %3d planes",
									XYZ[Z_Axis], Total_Planes[Z_Axis]);
			 WindowPrintf(pw, "\n A block of %3d planes is periodic",
									Periodic_Planes[Z_Axis]);
			 if((Periodic_Planes[Selected_Axis]*j != cell_planes) ||
			  (p_block <= 0.))
				WindowPrintf(pw, "\n Cell size is not a multiple of periodic block");
			 WindowPrintf(pw, "\n Periodic block = %6.2f ? ", p_block);
			 p_block = get_float(p_block);

		  Z_Front = 0;
		  Z_Back = 0;
		  WindowPrintf(pw, "\nExtend cell from : ");
		  Z_Front = get_float(Z_Front);
		  WindowPrintf(pw, "\n             to  : ");
		  Z_Back = get_float(Z_Back);

		  if(Z_Front < Z_Back)
			{
			 a = Z_Back;
			 Z_Back = Z_Front;
			 Z_Front = a;
			}

/* Now extend the cell  towards +Z direction */

		  File_Modification = DESH_YES;

		  atom_ptr = atom_ptr_temp;
		  for(i = 0; i < Total_Atoms; atom_ptr++, i++);

		  atom_ptr_bottom = atom_ptr;
		  atoms_added = 1;
		  revised_total_atoms = Total_Atoms;

		  block_no = 1.;
		  while(atoms_added > 0)
			{
			 atom_ptr = atom_ptr_temp;
			 atoms_added = 0;
			 i = 0;
			 while(i < Total_Atoms)
			  {
				if(atom_ptr->ZC + block_no * p_block <= Z_Front)
				 {
				  atom_ptr_bottom->XC = atom_ptr->XC;
				  atom_ptr_bottom->YC = atom_ptr->YC;
				  atom_ptr_bottom->ZC = atom_ptr->ZC + block_no * p_block;
				  atom_ptr_bottom->TYPE = atom_ptr->TYPE;
				  atom_ptr_bottom->PLANE = 0;
				  atoms_added++;
				  atom_ptr_bottom++;
				  revised_total_atoms++;
				  if(revised_total_atoms >= MAX_ATOMS)
					{
					 WindowPrintf(pw, "\n Number of atoms exceeded max limit");
					 WindowPrintf(pw, "\n Hit any key to continue.....");
					 i=getch();
					 WindowHide(pw, NOEFFECT);
					 return(POPUP_CONTINUE);
					}
				 }
				i++;
				atom_ptr++;
			  }
			 block_no++;
			}

/* Now extend the cell  towards -Z direction */

		  atoms_added = 1;
		  block_no = 1.;
		  while(atoms_added > 0)
			{
			 atom_ptr = atom_ptr_temp;
			 atoms_added = 0;
			 i = 0;
			 while(i < Total_Atoms)
			  {
				if(atom_ptr->ZC - block_no * p_block >= Z_Back)
				 {
				  atom_ptr_bottom->XC = atom_ptr->XC;
				  atom_ptr_bottom->YC = atom_ptr->YC;
				  atom_ptr_bottom->ZC = atom_ptr->ZC - block_no * p_block;
				  atom_ptr_bottom->TYPE = atom_ptr->TYPE;
				  atom_ptr_bottom->PLANE = 0;
				  atoms_added++;
				  atom_ptr_bottom++;
				  revised_total_atoms++;
				  if(revised_total_atoms >= MAX_ATOMS)
					{
					 WindowPrintf(pw, "\n Number of atoms exceeded max limit");
					 WindowPrintf(pw, "\n Hit any key to continue.....");
					 i=getch();
					 WindowHide(pw, NOEFFECT);
					 return(POPUP_CONTINUE);
					}
				 }
				i++;
				atom_ptr++;
			  }
			 block_no++;
			}
		  Total_Atoms = revised_total_atoms;
		  atom_ptr = atom_ptr_temp;
		  WindowClear(pw);
		  WindowPrintf(pw,"Number of atoms = %d\n",Total_Atoms);
		  WindowPrintf(pw,"\n Hit any key to continue ....");
		  i=getch();
		  WindowPrintf(pw,"Sorting the atoms .....");
		  planes_and_periodicity();
		  WindowPrintf(pw,"\n Hit any key to continue ....");
		  i=getch();
  WindowHide(pw, NOEFFECT);
  return(POPUP_CONTINUE);
 }





int menu_bond(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
	 int i;

	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 WindowPrintf(pw, "\n The bond length adjustment features is not implimented");
	 WindowPrintf(pw, "\n Hit any key to continue ...");
	 i=getch();
	 WindowClear(pw);
	 WindowHide(pw, NOEFFECT);
	 return(PULLDOWN_CONTINUE);

/* Do not remove the commented code. We need to use it later


	 bond_menu_array=PopupAllocate(BOND_ENTRIES);

	 sprintf(Bond_Entry[0], "%s   %7.4f", Bond_Phrases[0], Delta_R);
	 PopupCreateEntry(bond_menu_array, 1, Bond_Entry[0],
			1, 0, 0, input_bond_param);

	 sprintf(Bond_Entry[1], "%s   %7.4f", Bond_Phrases[1], Delta_Energy);
	 PopupCreateEntry(bond_menu_array, 2, Bond_Entry[1],
			2, 0, 0, input_bond_param);

	 sprintf(Bond_Entry[2], "%s   %d", Bond_Phrases[2], Iterations);
	 PopupCreateEntry(bond_menu_array, 3, Bond_Entry[2],
			3, 0, 0, input_bond_param);

	 sprintf(Bond_Entry[3], "%s   ", Bond_Phrases[3]);
	 PopupCreateEntry(bond_menu_array, 4, Bond_Entry[3],
			4, 0, 0, Bond_Length_Adjustment);

	 PopupEntryEnd(bond_menu_array, BOND_ENTRIES);
	 p_bond = PopupCreateMenu(bond_menu_array,
				  menu_colors,
					9,3,4,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
	 PopupSelectMenu(p_bond, 1, 1);
	 PopupDeallocate(bond_menu_array);
	 WindowClear(pw);
	 return(PULLDOWN_EXIT);

*/
	}

/*int	input_bond_param(POPUP_MENU_PTR p, unsigned which)
	{
	 char temp[50];

	 WindowClear(pw);
	 WindowDisplay(pw, 1, EXPLODE);
	 WindowPrintf(pw, "%s ? ", Bond_Phrases[which-1]);

	 if(which == 1)
		{
		Delta_R = get_float(Delta_R);
		sprintf(temp, "%s   %7.4f",Bond_Phrases[which-1],Delta_R);
		PopupChangeEntryString(p_bond, which, temp);
	  }
	 if(which == 2)
	  {
		Delta_Energy = get_float(Delta_Energy);
		sprintf(temp, "%s   %7.4f",Bond_Phrases[which-1],Delta_Energy);
		PopupChangeEntryString(p_bond, which, temp);
		}
	 if(which == 3)
		{
		Iterations = get_integer(Iterations);
		sprintf(temp, "%s   %d",Bond_Phrases[which-1],Iterations);
		PopupChangeEntryString(p_bond, which, temp);
		}
	 WindowHide(pw, NOEFFECT);
	 return(POPUP_CONTINUE);
	}
*/



int menu_IAP_Select(PULLDOWN_MENU_PTR p, BAR_MENU_PTR b,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
		Setting_IAP_Element = DESH_YES;
		p_IAP_Action = PopupCreateMenu(IAP_Action_items,
					menu_colors,
					5,40,3,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
		PopupSelectMenu( p_IAP_Action, 1, 1);
		PopupMenuFree(p_IAP_Action);
		return(PULLDOWN_EXIT);
	}

int Modify_IAP_Param( POPUP_MENU_PTR p, unsigned which)
	{
		Setting_IAP_Element = DESH_YES;
		p_IAP_Alloy_Element_items = PopupCreateMenu(IAP_Alloy_element_items,
					menu_colors,
					9,35,10,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
		PopupSelectMenu( p_IAP_Alloy_Element_items, 1, Selected_IAP_Element+1);
		PopupMenuFree(p_IAP_Alloy_Element_items);
		return(POPUP_CONTINUE);
	}



int Set_IAP_Alloy_Element_Type( POPUP_MENU_PTR p, unsigned which)
	{
		int i;

		if(Setting_Ionic_Neb == DESH_YES)
			{
				Selected_Ionic_Neb=which-1;
				return(POPUP_EXIT);
			}

		if(Setting_IAP_Element == DESH_YES)
			{
				Selected_IAP_Element=which-1;
				IAP_menu_array=PopupAllocate(IAP_TYPES);
				for(i=0; i<IAP_TYPES; i++)
					{
						PopupCreateEntry(IAP_menu_array, i+1,
							IAP_Name[i], i+1, 0, 0, Set_IAP_Type);
					}
				PopupEntryEnd(IAP_menu_array, IAP_TYPES);
				p_IAP = PopupCreateMenu(IAP_menu_array,
					menu_colors,
					14, 31, IAP_TYPES,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
				i=Element[Selected_IAP_Element].IAP_TYPE+1;
				PopupSelectMenu( p_IAP, 1, i);
				PopupDeallocate( IAP_menu_array);
				PopupMenuFree(p_IAP);
				return(POPUP_CONTINUE);
			}
		else
			{
				Selected_Alloy_Atom_Type=which-1;
				return(POPUP_EXIT);
			}
	}


int Set_IAP_Type( POPUP_MENU_PTR p, unsigned which)
	{
		int i,j,k;
		char temp[50];
		FILE	*f_param;

		if((f_param = fopen("PAR_NAME.LST", "rt")) == NULL)
			{
				WindowClear(pw);
				WindowDisplay(pw, 1, EXPLODE);
				WindowPrintf(pw, "\n Can not open PAR_NAME.LST file");
				WindowPrintf(pw, "\n IAP Type not changed.");
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
				WindowHide(pw, NOEFFECT);
				return(POPUP_EXIT);
			}

		Current_IAP_Type_Selection=which-1;
		for(j=0; j<=Current_IAP_Type_Selection; j++)
			{
				for(k=0; k<IAP_ENTRIES; k++)
					{
						fscanf(f_param, "%s", temp);
						if(strlen(temp) >= 11)
							temp[11] = '\0';
						strcpy(param_name[k], temp);
					}
			}
		fclose(f_param);

		IAP_Param_menu_array=PopupAllocate(IAP_ENTRIES);
		for(j=0; j<IAP_ENTRIES; j++)
			{

/* Parameter "which-1" contains the the IAP_TYPE selected from the menu */

				if(Current_IAP_Type_Selection != SHELL_MODEL)
					sprintf(param_name_value[j], "%11.11s=  %15.7f", param_name[j],
								Element[Selected_IAP_Element].IAP_PAR[j]);
				else
					{
						if((j != 7) && (j != 11) && (j != 15))
							sprintf(param_name_value[j], "%11.11s=  %15.7f", param_name[j],
								Element[Selected_IAP_Element].IAP_PAR[j]);
						else
							sprintf(param_name_value[j], "%11.11s=  %s", param_name[j],
								Chem_Sym[(int)Element[Selected_IAP_Element].IAP_PAR[j]]);
					}

				PopupCreateEntry(IAP_Param_menu_array, j+1,
					param_name_value[j], j+1, 0, 0, Input_IAP_Param_Value);
			}
		PopupEntryEnd(IAP_Param_menu_array, IAP_ENTRIES);
		p_IAP_Param_menu_array = PopupCreateMenu(IAP_Param_menu_array,
					menu_colors,
					4, 2, IAP_ENTRIES,
					POPUPWRAP | POPUPSTATIC,
					WNULLFN, VWNULLFN);
		PopupSelectMenu(p_IAP_Param_menu_array, 1, 1);
		PopupDeallocate( IAP_Param_menu_array);
		PopupMenuFree(p_IAP_Param_menu_array);
		Selected_IAP_Type = which-1;
		Element[Selected_IAP_Element].IAP_TYPE = (char) Selected_IAP_Type;
		return(POPUP_EXIT);
	}

int Input_IAP_Param_Value( POPUP_MENU_PTR p, unsigned which)
	{
	 char temp[50];
	 int	Current_Ionic_Neb;
	 float a;

	 if(Current_IAP_Type_Selection != SHELL_MODEL)
		{
			 WindowClear(pw);
			 WindowDisplay(pw, 1, EXPLODE);
			 WindowPrintf(pw, "%s ? ", param_name[which-1]);
			 a = Element[Selected_IAP_Element].IAP_PAR[which-1];
			 a= get_float(a);
			 Element[Selected_IAP_Element].IAP_PAR[which-1] = a;
			 sprintf(temp, "%11.11s=  %15.7f",param_name[which-1],a);
			 PopupChangeEntryString(p_IAP_Param_menu_array, which, temp);
			 WindowHide(pw, NOEFFECT);
		}
	 else
		{
//	which starts at 1 and not 0, hence subtract 1
			if((which-1 != 7) && (which-1 != 11) && (which-1 != 15))
				{
					 WindowClear(pw);
					 WindowDisplay(pw, 1, EXPLODE);
					 WindowPrintf(pw, "%s ? ", param_name[which-1]);
					 a = Element[Selected_IAP_Element].IAP_PAR[which-1];
					 a= get_float(a);
					 Element[Selected_IAP_Element].IAP_PAR[which-1] = a;
					 sprintf(temp, "%11.11s=  %15.7f",param_name[which-1],a);
					 PopupChangeEntryString(p_IAP_Param_menu_array, which, temp);
					 WindowHide(pw, NOEFFECT);
				}
			else
				{
					Setting_Ionic_Neb = DESH_YES;
					Current_Ionic_Neb = Element[Selected_IAP_Element].IAP_PAR[(int)which];
					p_IAP_Alloy_Element_items = PopupCreateMenu(IAP_Alloy_element_items,
						menu_colors,
						12,25,10,
						POPUPWRAP | POPUPSTATIC,
						WNULLFN, VWNULLFN);
					PopupSelectMenu( p_IAP_Alloy_Element_items, 1, Current_Ionic_Neb+1);
					PopupMenuFree(p_IAP_Alloy_Element_items);
					Element[Selected_IAP_Element].IAP_PAR[which-1]=Selected_Ionic_Neb;
					sprintf(temp, "%11.11s=  %s",param_name[which-1],Chem_Sym[Selected_Ionic_Neb]);
					PopupChangeEntryString(p_IAP_Param_menu_array, which, temp);
					Setting_Ionic_Neb=DESH_NO;
				}
		}
	 return(POPUP_CONTINUE);
	}


int Read_IAP_Param_File( POPUP_MENU_PTR p, unsigned which)
	{
		int	i;
		char	param_file[50];
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw, "\n File name : ");
		if(get_string(param_file) == DESH_NO)
			{
				WindowHide(pw, NOEFFECT);
				return(POPUP_CONTINUE);
			}
		if(Read_Element_Parameters(param_file) == DESH_YES)
			{
				WindowPrintf(pw, "\n File %s not found", param_file);
				WindowPrintf(pw, "\n Hit any key to continue ...");
				i=getch();
			}
		WindowHide(pw, NOEFFECT);
		return(POPUP_CONTINUE);
	}


int Save_IAP_Param_File( POPUP_MENU_PTR p, unsigned which)
	{
		int i, j;
		char file_name[50];
		FILE	*f_element;
		char temp1[20];

		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw, "\n File name : ");
		if(get_string(file_name) == DESH_NO)
			{
				WindowHide(pw, NOEFFECT);
				return(POPUP_CONTINUE);
			}
		f_element=fopen(file_name, "wt");
		for(i=0; i<ELEMENTS_SUPPORTED; i++)
			{
				fprintf(f_element, "Element_%1d %s\n", i, Element_Names[i]);
				fprintf(f_element, "Lattice_X= %6.3f\n", Element[i].Lattice_A);
				fprintf(f_element, "Lattice_Y= %6.3f\n", Element[i].Lattice_B);
				fprintf(f_element, "Lattice_Z= %6.3f\n", Element[i].Lattice_C);
				fprintf(f_element, "Radius= %6.3f\n", Element[i].Radius);
				fprintf(f_element, "IAP_Type= %d\n", (int)Element[i].IAP_TYPE);
				for(j=0; j<IAP_ENTRIES; j++)
					{
						fprintf(f_element, "IAP_Par_%1d= %18.9f\n", j, Element[i].IAP_PAR[j]);
					}
				fprintf(f_element, "NU= %5.3f\n", Element[i].NU);
			}
		fclose(f_element);
		WindowHide(pw, NOEFFECT);
		return(POPUP_CONTINUE);
	}


void	set_plot_scales(float *a, float *b, float *c,
							 float *x1, float *x2, float *y1, float *y2,
							 float *z1, float *z2)
		{
			int j;

			if((*a >= *b) && (*a >= *c))
				j=0;
			if((*b >= *a) && (*b >= *c))
				j=1;
			if((*c >= *a) && (*c >= *b))
				j=2;

			switch (j)
				{
					case 0:
						{
					*b = *a;
					*x1 = subset[EDIT].XMIN;
					*x2 = subset[EDIT].XMAX;
					*y1 = (subset[EDIT].YMIN + subset[EDIT].YMAX - (*x2 - *x1))/2.;
					*y2 = *y1 + (*x2 - *x1);
					*c = *a;
					*z1 = (subset[EDIT].ZMIN + subset[EDIT].ZMAX - (*x2 - *x1))/2.;
					*z2 = *z1 + (*x2 - *x1);
					break;
						}
					case 1:
						{
					*a = *b;
					*y1 = subset[EDIT].YMIN;
					*y2 = subset[EDIT].YMAX;
					*x1 = (subset[EDIT].XMIN + subset[EDIT].XMAX - (*y2 - *y1))/2.;
					*x2 = *x1 + (*y2 - *y1);
					*c = *b;
					*z1 = (subset[EDIT].ZMIN + subset[EDIT].ZMAX - (*y2 - *y1))/2.;
					*z2 = *z1 + (*y2 - *y1);
					break;
						}
					case 2:
						{
					*a = *c;
					*z1 = subset[EDIT].ZMIN;
					*z2 = subset[EDIT].ZMAX;
					*x1 = (subset[EDIT].XMIN + subset[EDIT].XMAX - (*z2 - *z1))/2.;
					*x2 = *x1 + (*x2 - *x1);
					*b = *c;
					*y1 = (subset[EDIT].YMIN + subset[EDIT].YMAX - (*z2 - *z1))/2.;
					*y2 = *y1 + (*z2 - *z1);
					break;
						}
				}
		}




int menu_edit(PULLDOWN_MENU_PTR p, BAR_MENU_PTR B,
		 POPUP_MENU_PTR pop,
		 unsigned int hs, unsigned int vs)
	{
  int i, j, k, l, m, n, o, Current_Edit_Atom, User_Input, All_Done, i_Neb;
  float x1, x2, y1, y2, z1, z2;
  float a, b, c, d, g, g1, g2, h, rcut_i, rcut_j;
  float e, f, x, y, z, r, neb_x, neb_y, neb_z;
  double r2;
  float edit_delta;
  int maxx, maxy, ht, Neighbours, k1, j1;
  int v_left[4], v_top[4], v_width[4], v_height[4];
	char temp[40];
  int x_index[3], y_index[3];
  int plot_color;

  struct atom_specs *Edit_Atom_ptr, *Atom_Neb_ptr;

  if((Total_Atoms<=0) || (cell_planes <= 0))
	{
	 WindowClear(pw);
	 WindowDisplay(pw,1,NOEFFECT);
	 WindowPrintf(pw, "No cell to view\n");
	 WindowPrintf(pw, "No of atoms = %d   No of cell planes = %d\n",
				Total_Atoms, cell_planes);
	 WindowPrintf(pw,"\n Hit any key to continue ....");
	 i=getch();
	 WindowHide(pw,NOEFFECT);
//    return(PULLDOWN_CONTINUE);
	 return(PULLDOWN_EXIT);
	}

	if(Graphics_Error == DESH_YES)
	{
	 WindowClear(pw);
	 WindowDisplay(pw,1,NOEFFECT);
	 WindowPrintf(pw, "\nGraphics Error. Can not implement VIEW\n");
	 WindowPrintf(pw,"\n Hit any key to continue ....");
	 i=getch();
	 WindowHide(pw,NOEFFECT);
//    return(PULLDOWN_CONTINUE);
	 return(PULLDOWN_EXIT);
	}

  File_Modification = DESH_YES;

  edit_delta = 0.1;
  i=0;
  Edit_Atom_ptr=atom_ptr_temp;
  while(i < Total_Atoms)
	{
		if(check_within_subset(Edit_Atom_ptr->XC,
			 Edit_Atom_ptr->YC,
			 Edit_Atom_ptr->ZC,
			 EDIT) == DESH_IN_SIDE)
				break;
		i++;
		Edit_Atom_ptr++;
	}
  if(i >= Total_Atoms)
	{
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw, "\n The subset does not contain any atom");
		WindowPrintf(pw, "\n Hit any key to continue ...");
		i=getch();
		WindowHide(pw, NOEFFECT);
		return(PULLDOWN_EXIT);
	}

  Current_Edit_Atom = i;
  rcut_i = Element[Edit_Atom_ptr->TYPE].IAP_PAR[0];
	x = Edit_Atom_ptr->XC;
  y = Edit_Atom_ptr->YC;
  z = Edit_Atom_ptr->ZC;
  g1 = (float)sqrt((double)rcut_i);


/* return to graphics mode */
  setgraphmode(getgraphmode());
	maxx=getmaxx();	maxy=getmaxy();

  j = (int)((float)maxy * .45);
  k = ((maxy/2) - j) / 2;
	i = ((maxx/2) - j) / 2;
  v_left[0] = i;	v_left[1] = i + maxx/2;	v_left[2] = i;	v_left[3] = v_left[1];
  v_top[0] = maxy/2 + k;	v_top[1] = v_top[0];	v_top[2] = k; v_top[3] = v_top[2];
  for(i=0; i< 3; v_width[i] = j, v_height[i] = j, i++);

		if((subset[EDIT].TYPE == CUBIC) || (subset[EDIT].TYPE == ENTIRE_CELL))
		 {
			a = subset[EDIT].XMAX - subset[EDIT].XMIN;
			b = subset[EDIT].YMAX - subset[EDIT].YMIN;
			c = subset[EDIT].ZMAX - subset[EDIT].ZMIN;
			x1 = subset[EDIT].XMIN;	x2 = subset[EDIT].XMAX;
			y1 = subset[EDIT].YMIN;	y2 = subset[EDIT].YMAX;
			z1 = subset[EDIT].ZMIN;	z2 = subset[EDIT].ZMAX;
			set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

		if(subset[EDIT].TYPE == CYLINDRICAL)
		 {
	a = 2.*subset[EDIT].C_RMAX;
	b = a;
	c = subset[EDIT].ZMAX - subset[EDIT].ZMIN;
	x1 = -subset[EDIT].C_RMAX;
	x2 = subset[EDIT].C_RMAX;
	y1 = -subset[EDIT].C_RMAX;
	y2 = subset[EDIT].C_RMAX;
	z1 = subset[EDIT].ZMIN;	z2 = subset[EDIT].ZMAX;
	set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

		if(subset[EDIT].TYPE == SPHERICAL)
		 {
	a = 2.*subset[EDIT].SP_RMAX;
	b = a;
	c = a;
	x1 = -subset[EDIT].SP_RMAX;
	x2 = subset[EDIT].SP_RMAX;
	y1 = -subset[EDIT].SP_RMAX;
	y2 = subset[EDIT].SP_RMAX;
	z1 = -subset[EDIT].SP_RMAX;
	z2 = subset[EDIT].SP_RMAX;
	set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

		if(subset[EDIT].TYPE == SLICE)
		 {
	a = subset[EDIT].S_XMAX - subset[EDIT].S_XMIN;
	b = subset[EDIT].S_YMAX - subset[EDIT].S_YMIN;
	c = subset[EDIT].S_ZMAX - subset[EDIT].S_ZMIN;
	x1 = subset[EDIT].S_XMIN;	x2 = subset[EDIT].S_XMAX;
	y1 = subset[EDIT].S_YMIN;	y2 = subset[EDIT].S_YMAX;
	z1 = subset[EDIT].S_ZMIN;	z2 = subset[EDIT].S_ZMAX;
	set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

  setcolor(14);

	ht = textheight("W");


	User_Input= 'N';
	while(1)
  {
	  switch (User_Input)
		{
			case DESH_N:
			case	DESH_n:
				{
				  clearviewport();
					i=textwidth("CASA : ADESH !");
				  i = maxx/2 + ((maxx/2) - i)/2;
				  outtextxy(i, 2*ht, "CASA : ADESH !");
				  i=textwidth("914 226-1925, USA");
					i = maxx/2 + ((maxx/2) - i)/2;
					outtextxy(i, 4*ht, "914 226-1925, USA");

				  for(i=0; i<3; i++)
					{
						rectangle(v_left[i], v_top[i],
									v_left[i]+v_width[i], v_top[i]+v_height[i]);
					}
					plot_color=3;
				  i=cell_planes;
				  while(i>=1)
					{
					 setfillstyle(1,plot_color);
					 atom_ptr=atom_ptr_temp;
					 j=0;
					 while(j<Total_Atoms)
						{
						if(atom_ptr->PLANE == i)
						 {
							if(check_within_subset(atom_ptr->XC,
								 atom_ptr->YC,
								 atom_ptr->ZC,
								 EDIT) == DESH_IN_SIDE)
							 {
								if(atom_ptr->TYPE == VACANCY)
									setfillstyle(1,VACANCY);
								r = Element[atom_ptr->TYPE].Radius;
								m = (int)((float)v_height[0]*r/a);
								n = (int)((float)v_height[0]*r/b);

								k = (int)((float)v_width[0] *
									(atom_ptr->XC - x1) / a) + v_left[0];
								l = (int)((float)v_height[0] *
									(atom_ptr->YC - y1) / b);
								l = v_height[0] - l + v_top[0];
								fillellipse(k,l,m,n);

								k = (int)((float)v_width[1] *
									(atom_ptr->ZC - z1) / c) + v_left[1];
								l = (int)((float)v_height[1] *
									(atom_ptr->YC - y1) / b);
								l = v_height[1] - l + v_top[1];
								fillellipse(k,l,m,n);

								k = (int)((float)v_width[2] *
								  (atom_ptr->XC - x1) / a) + v_left[2];
								l = (int)((float)v_height[2] *
								  (atom_ptr->ZC - z1) / c);
								l = v_height[2] - l + v_top[2];
								fillellipse(k,l,m,n);
								if(atom_ptr->TYPE == VACANCY)
									setfillstyle(1,plot_color);
							 }
						 }
						atom_ptr++;
						j++;
						}

					 i--;
					 plot_color++;
					 if(plot_color > Periodic_Planes[2]+3)
						plot_color=3;
					 if(plot_color > 13)
						plot_color=3;
					}

				 Atom_Neb_ptr=atom_ptr_temp;
				 j=0;
				 Neighbours=0;
				 plot_color=1;
				 setfillstyle(1,plot_color);
				 while(j < Total_Atoms)
					{
						if(j != Current_Edit_Atom)
							{
								d = Atom_Neb_ptr->XC;
								e = Atom_Neb_ptr->YC;
								f = Atom_Neb_ptr->ZC;
								rcut_j = Element[(int)Atom_Neb_ptr->TYPE].IAP_PAR[0];
								g2=(float)sqrt((double)rcut_j);
								h=(g1+g2)/2.;
								g=h*h;
								if( Is_Neb(x, y, z, d, e, f, h, g) == 0)
									{
										if(Atom_Neb_ptr->TYPE == VACANCY)
											setfillstyle(1,VACANCY);

										r = Element[Atom_Neb_ptr->TYPE].Radius;
										m = (int)((float)v_height[0]*r/a);
										n = (int)((float)v_height[0]*r/b);

										for(i_Neb=0; i_Neb < Periodic_Nebs_Found; i_Neb++)
											{

										k = (int)((float)v_width[0] *
												(x - Periodic_Neb_Positions[i_Neb][0] - x1) / a) + v_left[0];
										l = (int)((float)v_height[0] *
												(y - Periodic_Neb_Positions[i_Neb][1] - y1) / b);
										l = v_height[0] - l + v_top[0];
										fillellipse(k,l,m,n);

										k = (int)((float)v_width[1] *
												(z - Periodic_Neb_Positions[i_Neb][2] - z1) / c) + v_left[1];
										l = (int)((float)v_height[1] *
												(y - Periodic_Neb_Positions[i_Neb][1] - y1) / b);
										l = v_height[1] - l + v_top[1];
										fillellipse(k,l,m,n);

										k = (int)((float)v_width[2] *
												(x - Periodic_Neb_Positions[i_Neb][0] - x1) / a) + v_left[2];
										l = (int)((float)v_height[2] *
												(z - Periodic_Neb_Positions[i_Neb][2] - z1) / c);
										l = v_height[2] - l + v_top[2];
										fillellipse(k,l,m,n);

										if(Atom_Neb_ptr->TYPE == VACANCY)
											setfillstyle(1,plot_color);

										Neighbours++;
											}
									}
							}
						Atom_Neb_ptr++;
						j++;
					}

					sprintf(temp," Neighbours : %d",Neighbours);
					outtextxy(v_left[3], v_top[3]+9*ht, temp);
					sprintf(temp," Type : %s", Chem_Sym[(int)Edit_Atom_ptr->TYPE]);
					outtextxy(v_left[3], v_top[3]+7*ht, temp);

					sprintf(temp, "         T : Change atom type");
					outtextxy(v_left[3], v_top[3]+12*ht, temp);
					sprintf(temp, "      %c %c: Move along X", LEFT_ARROW, RIGHT_ARROW);
					outtextxy(v_left[3], v_top[3]+14*ht, temp);
					sprintf(temp, "      %c %c: Move along Y", UP_ARROW, DOWN_ARROW);
					outtextxy(v_left[3], v_top[3]+16*ht, temp);
					sprintf(temp, " ALT F & B : Front & Back along Z");
					outtextxy(v_left[3], v_top[3]+18*ht, temp);
					sprintf(temp, "     Enter : Next atom");
					outtextxy(v_left[3], v_top[3]+20*ht, temp);
					sprintf(temp, "       Esc : Exit");
					outtextxy(v_left[3], v_top[3]+22*ht, temp);




				 plot_color=2;
				 setfillstyle(1,plot_color);

				 r = Element[Edit_Atom_ptr->TYPE].Radius;
				 m = (int)((float)v_height[0]*r/a);
				 n = (int)((float)v_height[0]*r/b);

				 k = (int)((float)v_width[0] *
							(x - x1) / a) + v_left[0];
				 l = (int)((float)v_height[0] *
							(y - y1) / b);
				 l = v_height[0] - l + v_top[0];
				 fillellipse(k,l,m,n);

				 k = (int)((float)v_width[1] *
							(z - z1) / c) + v_left[1];
				 l = (int)((float)v_height[0] *
							(y - y1) / b);
				 l = v_height[1] - l + v_top[1];
				 fillellipse(k,l,m,n);

				 k = (int)((float)v_width[2] *
							(x - x1) / a) + v_left[2];
				 l = (int)((float)v_height[2] *
							(z - z1) / b);
				 l = v_height[2] - l + v_top[2];
				 fillellipse(k,l,m,n);


				 All_Done=DESH_NO;
				 User_Input=getch();
				 break;
				}


				case 0:
					{
						k1=getch();
									switch(k1)
										{
											case DESH_R_ARROW:
												{
													Edit_Atom_ptr->XC = x + edit_delta;
													x = Edit_Atom_ptr->XC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}

											case DESH_L_ARROW:
												{
													Edit_Atom_ptr->XC = x - edit_delta;
													x = Edit_Atom_ptr->XC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}

											case DESH_U_ARROW:
												{
													Edit_Atom_ptr->YC = y + edit_delta;
													y = Edit_Atom_ptr->YC;
													User_Input = 'N';
													All_Done=DESH_NO;
													break;
												}

											case DESH_D_ARROW:
												{
													Edit_Atom_ptr->YC = y - edit_delta;
													y = Edit_Atom_ptr->YC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}


											case DESH_ALT_F:
												{
													Edit_Atom_ptr->ZC = z + edit_delta;
													z = Edit_Atom_ptr->ZC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}

											case DESH_ALT_B:
												{
													Edit_Atom_ptr->ZC = z - edit_delta;
													z = Edit_Atom_ptr->ZC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}



											default:
												{
													User_Input = DESH_YES;
													All_Done = DESH_NO;
												}
										}
//								}
							break;
					}


			case DESH_ENTER:
				{
					while(Current_Edit_Atom < Total_Atoms)
						{
							Edit_Atom_ptr++;
							Current_Edit_Atom++;
							if(check_within_subset(Edit_Atom_ptr->XC,
									 Edit_Atom_ptr->YC,
									 Edit_Atom_ptr->ZC,
									 EDIT) == DESH_IN_SIDE)
								break;
						}
					if(Current_Edit_Atom >= Total_Atoms)
						{
							All_Done=DESH_YES;
							break;
						}

					x = Edit_Atom_ptr->XC;
					y = Edit_Atom_ptr->YC;
					z = Edit_Atom_ptr->ZC;
					rcut_i = Element[Edit_Atom_ptr->TYPE].IAP_PAR[0];
					g1 = (float)sqrt((double)rcut_i);
					All_Done=DESH_NO;
					User_Input='N';
					break;
				}

			case DESH_ESCAPE:
				{
					All_Done=DESH_YES;
					break;
				}

			case DESH_T:
			case DESH_t:
				{
					setviewport(0,0,maxx,maxy,1);
					restorecrtmode();
					Setting_IAP_Element = DESH_NO;
					p_IAP_Alloy_Element_items = PopupCreateMenu(IAP_Alloy_element_items,
						menu_colors,
						9,35,10,
						POPUPWRAP | POPUPSTATIC,
						WNULLFN, VWNULLFN);
					Selected_Alloy_Atom_Type = Edit_Atom_ptr->TYPE;
					PopupSelectMenu( p_IAP_Alloy_Element_items, 1,
											Selected_Alloy_Atom_Type+1);
					PopupMenuFree(p_IAP_Alloy_Element_items);
					Edit_Atom_ptr->TYPE = Selected_Alloy_Atom_Type;
					All_Done=DESH_NO;
					User_Input='N';
					setgraphmode(getgraphmode());
					break;
				}

			default:
						{
							All_Done=DESH_NO;
							printf("\a");
							User_Input=getch();
						}

		}
		if(All_Done == DESH_YES)
			break;
	}
	setviewport(0,0,maxx,maxy,1);
	restorecrtmode();
	return(PULLDOWN_EXIT);
	}


void	show_user(void)
	{
		WindowClear(pw);
		WindowDisplay(pw, 1, EXPLODE);
		WindowPrintf(pw, "      This ADESH program is for the exclusive use for\n");
		WindowPrintf(pw, "      %s\n    %s  %s\n", user_id, user_name, user_institute);
		WindowPrintf(pw, " Copyright (c) CASA, USA ,\n");
		WindowPrintf(pw, " For help, call : (914) 226 - 1925\n");
		WindowPrintf(pw, " Please wait");
		delay(3000);
		WindowHide(pw, NOEFFECT);
		delay(100);
   }
